Package: blme
Version: 1.0-7
Date: 2026-01-05
Title: Bayesian Linear Mixed-Effects Models
Authors@R: c(
  person("Vincent", "Dorie", role = c("aut", "cre"), email = "vdorie@gmail.com", comment = c(ORCID = "0000-0002-9576-3064")),
  person("Douglas", "Bates", role = "ctb", comment = c("lme4 non-modular functions", ORCID = "0000-0001-8316-9503")),
  person("Martin", "Maechler", role = "ctb", comment = c("lme4 non-modular functions", ORCID = "0000-0002-8685-9910")),
  person("Ben", "Bolker", role = "ctb", comment = c("lme4 non-modular functions", ORCID = "0000-0002-2127-0443")),
  person("Steven", "Walker", role = "ctb", comment = c("lme4 non-modular functions", ORCID = "0000-0002-4394-9078")))
Depends: R (>= 3.0-0), lme4 (>= 1.0-6)
Imports: methods, stats, utils
Suggests: expint (>= 0.1-3), testthat
Description: Maximum a posteriori estimation for linear and generalized linear mixed-effects models in a Bayesian setting, implementing the methods of Chung, et al. (2013) <doi:10.1007/s11336-013-9328-2>. Extends package 'lme4' (Bates, Maechler, Bolker, and Walker (2015) <doi:10.18637/jss.v067.i01>).
License: GPL (>= 2)
URL: https://github.com/vdorie/blme
BugReports: https://github.com/vdorie/blme/issues
NeedsCompilation: no
Packaged: 2026-01-05 23:54:23 UTC; vdorie
Author: Vincent Dorie [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-9576-3064>),
  Douglas Bates [ctb] (lme4 non-modular functions, ORCID:
    <https://orcid.org/0000-0001-8316-9503>),
  Martin Maechler [ctb] (lme4 non-modular functions, ORCID:
    <https://orcid.org/0000-0002-8685-9910>),
  Ben Bolker [ctb] (lme4 non-modular functions, ORCID:
    <https://orcid.org/0000-0002-2127-0443>),
  Steven Walker [ctb] (lme4 non-modular functions, ORCID:
    <https://orcid.org/0000-0002-4394-9078>)
Maintainer: Vincent Dorie <vdorie@gmail.com>
Repository: CRAN
Date/Publication: 2026-01-10 07:51:49 UTC
Built: R 4.6.0; ; 2026-04-26 06:09:38 UTC; unix

Package: blme
Version: 1.0-7
Date: 2026-01-05
Title: Bayesian Linear Mixed-Effects Models
Authors@R: c(
  person("Vincent", "Dorie", role = c("aut", "cre"), email = "vdorie@gmail.com", comment = c(ORCID = "0000-0002-9576-3064")),
  person("Douglas", "Bates", role = "ctb", comment = c("lme4 non-modular functions", ORCID = "0000-0001-8316-9503")),
  person("Martin", "Maechler", role = "ctb", comment = c("lme4 non-modular functions", ORCID = "0000-0002-8685-9910")),
  person("Ben", "Bolker", role = "ctb", comment = c("lme4 non-modular functions", ORCID = "0000-0002-2127-0443")),
  person("Steven", "Walker", role = "ctb", comment = c("lme4 non-modular functions", ORCID = "0000-0002-4394-9078")))
Depends: R (>= 3.0-0), lme4 (>= 1.0-6)
Imports: methods, stats, utils
Suggests: expint (>= 0.1-3), testthat
Description: Maximum a posteriori estimation for linear and generalized linear mixed-effects models in a Bayesian setting, implementing the methods of Chung, et al. (2013) <doi:10.1007/s11336-013-9328-2>. Extends package 'lme4' (Bates, Maechler, Bolker, and Walker (2015) <doi:10.18637/jss.v067.i01>).
License: GPL (>= 2)
URL: https://github.com/vdorie/blme
BugReports: https://github.com/vdorie/blme/issues
NeedsCompilation: no
Packaged: 2026-01-05 23:54:23 UTC; vdorie
Author: Vincent Dorie [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-9576-3064>),
  Douglas Bates [ctb] (lme4 non-modular functions, ORCID:
    <https://orcid.org/0000-0001-8316-9503>),
  Martin Maechler [ctb] (lme4 non-modular functions, ORCID:
    <https://orcid.org/0000-0002-8685-9910>),
  Ben Bolker [ctb] (lme4 non-modular functions, ORCID:
    <https://orcid.org/0000-0002-2127-0443>),
  Steven Walker [ctb] (lme4 non-modular functions, ORCID:
    <https://orcid.org/0000-0002-4394-9078>)
Maintainer: Vincent Dorie <vdorie@gmail.com>
Repository: CRAN
Date/Publication: 2026-01-10 07:51:49 UTC
Built: R 4.6.0; ; 2026-04-25 16:22:11 UTC; unix

getLMMData <- function() {
  set.seed(0, "Mersenne-Twister", "Inversion")
  
  N <- 100
  J.1 <- 5
  J.2 <- 5
  beta <- c(5, 2, 4)
  theta.1 <- matrix(rnorm(J.1 * 2), J.1, 2)
  theta.2 <- matrix(rnorm(J.2 * 3), J.2, 3)
  
  x.1 <- rnorm(N)
  x.2 <- rnorm(N)
  g.1 <- rmultinom(N, 1, runif(J.1))
  g.2 <- rmultinom(N, 1, runif(J.2))
  g.1 <- sapply(1:N, function(i) which(g.1[,i] == 1))
  g.2 <- sapply(1:N, function(i) which(g.2[,i] == 1))
  
  y <- 1   * (beta[1] + theta.1[g.1,1] + theta.2[g.2,1]) +
       x.1 * (beta[2] + theta.1[g.1,2] + theta.2[g.2,2]) +
       x.2 * (beta[3] +                  theta.2[g.2,3]) +
       rnorm(N)
  
  weights <- runif(N)
  weights <- weights / sum(weights)
  
  return(data.frame(y = y, x.1 = x.1, x.2 = x.2, g.1 = g.1, g.2 = g.2, w = weights))
}
testData <- getLMMData()
rm(getLMMData)

checkWarning <- function (expr, msg = "", silent = getOption("RUnit")$silent) 
{
  tryWarn <- function (expr, silent = FALSE) {
    tryCatch(expr, warning = function(e) {
      call <- conditionCall(e)
      if (!is.null(call)) {
        if (identical(call[[1L]], quote(doTryCatch))) 
          call <- sys.call(-4L)
        dcall <- deparse(call)[1L]
        prefix <- paste("Warning in", dcall, ": ")
        LONG <- 75L
        msg <- conditionMessage(e)
        sm <- strsplit(msg, "\n")[[1L]]
        w <- 14L + nchar(dcall, type = "w") + nchar(sm[1L], 
                                  type = "w")
        if (is.na(w)) 
          w <- 14L + nchar(dcall, type = "b") + nchar(sm[1L], 
                                    type = "b")
        if (w > LONG) 
          prefix <- paste(prefix, "\n  ", sep = "")
      }
      else prefix <- "Warning : "
      msg <- paste(prefix, conditionMessage(e), "\n", sep = "")
      .Internal(seterrmessage(msg[1L]))
      if (!silent && identical(getOption("show.error.messages"), 
                               TRUE)) {
        cat(msg, file = stderr())
        .Internal(printDeferredWarnings())
      }
      invisible(structure(msg, class = "try-error"))
    })
  }

    if (missing(expr)) {
        stop("'expr' is missing")
    }
    if (is.null(silent)) {
        silent <- FALSE
        warning("'silent' has to be of type 'logical'. Was NULL. Set to FALSE.")
    }
    if (RUnit:::.existsTestLogger()) {
        .testLogger$incrementCheckNum()
    }
    if (!inherits(tryWarn(eval(expr, envir = parent.frame()), silent = silent), 
        "try-error")) {
        if (RUnit:::.existsTestLogger()) {
            .testLogger$setFailure()
        }
        stop("Warning not generated as expected\n", msg)
    }
    else {
        return(TRUE)
    }
}

## "control" refers to how optimization should proceed, i.e. which parameters
## need numeric and which can be profiled out

## hack this as on "common scale" is really inconvenient here
getResidPriorDFAdjustment <- function(residPrior)
{
  if (is(residPrior, "bmerGammaDist")) {
    return(-(residPrior@shape - 1.0) * if (residPrior@posteriorScale == 'sd') 1 else 2)
  } else if (is(residPrior, "bmerInvGammaDist")) {
    return( (residPrior@shape + 1.0) * if (residPrior@posteriorScale == 'sd') 1 else 2)
  }
  0
}

getThetaLowerBoundsForDimension <- function(d) {
  if (d == 1) return(0)
  c(0, rep(-Inf, d - 1), getThetaLowerBoundsForDimension(d - 1))
}

## TODO: this should eventually not assume the ranef structure but instead
## suck it from Lind and theta, if possible
getRanefStructure <- function(pred, resp, reTrms) {
  ranefStructure <- list(numCovParameters = sum(sapply(reTrms$cnms, function(cnm) { d <- length(cnm); d * (d + 1) / 2; })),
                         numRanefPerFactor = diff(reTrms$Gp),
                         numCoefPerFactor = as.integer(sapply(reTrms$cnms, length)),
                         numFactors = length(reTrms$cnms))
  ranefStructure$numGroupsPerFactor <- as.integer(ranefStructure$numRanefPerFactor / ranefStructure$numCoefPerFactor + 0.5)
  ranefStructure$lower <- as.numeric(unlist(sapply(ranefStructure$numCoefPerFactor, getThetaLowerBoundsForDimension)))
  
  ranefStructure
}

createBlmerControl <- function(pred, resp, priors)
{
  df <- 0 ## adjustment to polynomial (sigma.sq)^{-df/2}
  constant <- 0 ## normalizing constants and the like. On deviance (-2 log) scale

  numFactors <- length(priors$covPriors)
 
  df <- df + getDFAdjustment(priors$fixefPrior) + getResidPriorDFAdjustment(priors$residPrior)
  constant <- constant + getConstantTerm(priors$fixefPrior) + getConstantTerm(priors$residPrior)

  for (i in seq_len(numFactors)) {
    df <- df + getDFAdjustment(priors$covPrior[[i]])
    constant <- constant + getConstantTerm(priors$covPrior[[i]])
  }

  fixefOptimizationType <- getFixefOptimizationType(pred, resp, priors)
  sigmaOptimizationType <- getSigmaOptimizationType(resp, priors)
  
  namedList(df, constant, fixefOptimizationType, sigmaOptimizationType)
}

FIXEF_OPTIM_NA      <- "na"      ## no fixefs in model
FIXEF_OPTIM_NUMERIC <- "numeric" ## brute force by adding to numeric optimizer
FIXEF_OPTIM_LINEAR  <- "linear"  ## mle found by root of linear equation. or, don't worry about it
getFixefOptimizationType <- function(pred, resp, priors)
{
  if (length(pred$X) == 0) return(FIXEF_OPTIM_NA)
  
  if (!is(resp, "lmerResp")) return(FIXEF_OPTIM_NUMERIC)
  
  fixefPrior <- priors$fixefPrior
  
  if (is(fixefPrior, "bmerTDist") || is(fixefPrior, "bmerHorseshoeDist")) return(FIXEF_OPTIM_NUMERIC)

  FIXEF_OPTIM_LINEAR
}

## determines how to optimize over sigma
## possible values are:
SIGMA_OPTIM_NA           <- "na"                 ## doesn't apply
SIGMA_OPTIM_NUMERIC      <- "numeric"            ## brute force by adding to numeric optimizer
SIGMA_OPTIM_POINT        <- "point"              ## sigma is fixed to a particular value
SIGMA_OPTIM_SQ_LINEAR    <- "sigma.sq.linear"    ## sigma.sq.hat is root to linear equation
SIGMA_OPTIM_SQ_QUADRATIC <- "sigma.sq.quadratic" ## sigma.sq.hat is root to quadratic equation
SIGMA_OPTIM_QUADRATIC    <- "sigma.quadratic"    ## sigma.hat is root to quadratic equation

getSigmaOptimizationType <- function(resp, priors)
{
  if (!is(resp, "lmerResp")) return(SIGMA_OPTIM_NA)
  
  fixefPrior <- priors$fixefPrior
  covPriors  <- priors$covPriors
  residPrior <- priors$residPrior

  if (is(residPrior, "bmerPointDist")) return(SIGMA_OPTIM_POINT)
  
  if (is(fixefPrior, "bmerNormalDist") && fixefPrior@commonScale == FALSE)
    return(SIGMA_OPTIM_NUMERIC)
  if ((is(fixefPrior, "bmerTDist") || is(fixefPrior, "bmerHorseshoeDist")) && fixefPrior@commonScale == TRUE)
    return(SIGMA_OPTIM_NUMERIC)
  
  exponentialTerms <- c()
  for (i in seq_along(covPriors)) {
    covPrior.i <- covPriors[[i]]

    if (is(covPrior.i, "bmerCustomDist") && covPrior.i@commonScale == FALSE) return(SIGMA_OPTIM_NUMERIC)
    
    exponentialTerm <- getExponentialSigmaPower(covPrior.i)
    if (exponentialTerm != 0) exponentialTerms <- union(exponentialTerms, exponentialTerm)
  }
  exponentialTerm <- getExponentialSigmaPower(residPrior)
  if (exponentialTerm != 0) exponentialTerms <- union(exponentialTerms, exponentialTerm)

  ## exp(-0.5 * sigma^-2 * stuff) always happens, so other terms are "extra"
  extraExponentialTerms <- setdiff(exponentialTerms, -2)
  
  if (length(extraExponentialTerms) == 0L) return(SIGMA_OPTIM_SQ_LINEAR)
  
  if (length(extraExponentialTerms) > 1L || !(extraExponentialTerms %in% c(-1, 2)))
    return(SIGMA_OPTIM_NUMERIC)

  if (extraExponentialTerms == -1) return(SIGMA_OPTIM_QUADRATIC)
  if (extraExponentialTerms ==  2) return(SIGMA_OPTIM_SQ_QUADRATIC)

  ## should be unreachable
  SIGMA_OPTIM_NUMERIC
}

getGLMMData <- function() {
  set.seed(3, "Mersenne-Twister", "Inversion")
  J <- 4
  n <- 8
  N <- J * n
  x.1 <- rnorm(N)
  x.2 <- rnorm(N)
  theta <- rnorm(J, 0, 2)
  theta.g <- rep(theta, rep(n, J))
  eta <- 3 * x.1 + 2 * x.2 + theta.g
  mu <- exp(eta) / (1 + exp(eta))
  y <- rbinom(N, 1, mu)

  g <- gl(J, n)

  return(data.frame(y = y, x.1 = x.1, x.2 = x.2, g = g))
}
testData <- getGLMMData()
rm(getGLMMData)

setClass("bmerNormalDist",
         representation(R.cov.inv = "matrix"),
         contains = "bmerDist")

toString.bmerNormalDist <- function(x, digits = getOption("digits"), ...) {
  if (any(diag(x@R.cov.inv) == 0)) {
    cov <- diag(1 / diag(x@R.cov.inv)^2)
    sds <- sqrt(diag(cov))
    corrs <- matrix(0, nrow(cov), ncol(cov))
  } else {
    cov <- crossprod(solve(x@R.cov.inv))
    sds <- sqrt(diag(cov))
    corrs <- diag(1 / sds) %*% cov %*% diag(1 / sds)
  }
  
  sds <- round(sds, digits)
  corrs <- round(corrs[lower.tri(corrs)], digits)
  
  if (nrow(cov) > 2L) {
    covString <- paste0("sd = c(", paste0(round(sds[1L:2L], digits), collapse = ", "),
                        ", ...), corr = c(", round(corrs[1L], digits), " ...)")
  } else if (nrow(cov) == 2L) {
    covString <- paste0("sd = c(", paste0(round(sds[1L:2L], digits), collapse = ", "),
                        "), corr = ", round(corrs[1L], digits))
  } else {
    covString <- paste0("sd = ", round(sds[1L], digits))
  }
  
  paste0("normal(", covString, ", ",
         "common.scale = ", x@commonScale, ")")
}

setMethod("getDFAdjustment", "bmerNormalDist",
  function(object) {
    if (object@commonScale == TRUE) sum(diag(object@R.cov.inv) != 0) else 0
  }
)
setMethod("getConstantTerm", "bmerNormalDist",
  function(object) {
    R.cov.inv <- object@R.cov.inv
    if (any(diag(R.cov.inv) < 0)) return(NA)
    
    nonZeroes <- diag(R.cov.inv) != 0
    rank <- sum(nonZeroes)
    
    rank * log(2 * pi) - 2.0 * sum(log(diag(R.cov.inv)[nonZeroes]))
  }
)
setMethod("getExponentialSigmaPower", "bmerNormalDist",
  function(object) { if (object@commonScale == TRUE) -2 else 0 }
)
setMethod("getExponentialTerm", "bmerNormalDist",
  function(object, beta) {
    exponential <- tcrossprod(crossprod(beta, object@R.cov.inv))[1]
    if (object@commonScale == TRUE) c(-2, exponential) else c(0, exponential)
  }
)

setClass("bmerDist", representation(commonScale = "logical"),
         contains = "VIRTUAL")

if (!isGeneric("getDFAdjustment"))
  setGeneric("getDFAdjustment", function(object, ...) standardGeneric("getDFAdjustment"))
if (!isGeneric("getConstantTerm"))
  setGeneric("getConstantTerm", function(object, ...) standardGeneric("getConstantTerm"))
## what power sigma has if prior induces exp(-0.5 * sigma^pow * stuff)
if (!isGeneric("getExponentialSigmaPower"))
  setGeneric("getExponentialSigmaPower", function(object, ...) standardGeneric("getExponentialSigmaPower"))
## whatever is going on in the exponent, and what power sigma has connected with it
## note, relative to -1 / 2
if (!isGeneric("getExponentialTerm"))
  setGeneric("getExponentialTerm", function(object, ...) standardGeneric("getExponentialTerm"))
if (!isGeneric("getPolynomialTerm"))
  setGeneric("getPolynomialTerm", function(object, ...) standardGeneric("getPolynomialTerm"))

setMethod("getDFAdjustment", "ANY", function(object, ...) 0)
setMethod("getConstantTerm", "ANY", function(object, ...) 0)
setMethod("getExponentialSigmaPower", "ANY", function(object, ...) 0)
setMethod("getExponentialTerm", "ANY", function(object, ...) c(0, 0))
setMethod("getPolynomialTerm", "ANY", function(object, ...) 0)
          

fixefDistributions <- c("flat", "normal", "t", "horseshoe")
covDistributions   <- c("flat", "wishart", "invwishart",
                        "gamma", "invgamma", "custom")
residDistributions <- c("flat", "gamma", "invgamma", "point")

lmmDistributions <- list(
  flat = function() NULL,
  normal = function(sd = c(10, 2.5), cov, common.scale = TRUE) {
    matchedCall <- match.call()
    if (!is.null(matchedCall$sd)) sd <- eval(matchedCall$sd)
    if (!is.null(matchedCall$cov)) cov <- eval(matchedCall$cov)
    if (!is.null(matchedCall$sd) && !is.null(matchedCall$cov))
      warning("both sd and cov supplied to normal - only cov will be used")
    common.scale <- blme:::deparseCommonScale(common.scale)

    if (missing(cov) && !is.null(sd)) {
      if (!is.null(names(sd)) && any(names(sd) %not_in% .fixefNames & names(sd) != ""))
        stop("unrecognized fixed effects for normal prior: '",
             paste0(names(sd)[names(sd) %not_in% .fixefNames & names(sd) != ""], collapse = "', '"), "'")
      
      sd <- sd^2
      if (length(sd) == 1L) {
        cov <- if (!is.null(names(sd))) {
          diag(c(rep_len(Inf, which(.fixefNames %in% names(sd)) - 1L),
                 sd,
                 rep_len(Inf, p - which(.fixefNames %in% names(sd)))), p)
        } else { diag(sd, p) }
      } else if (length(sd) == 2L && p > 2L) {
        if (!is.null(names(sd)) && any(names(sd) != "")) {
          if (!any(names(sd) == ""))
            stop("for 2-parameter default normal prior specification with names, the default name must be left blank")
          sd <- c(rep_len(sd[names(sd) == ""], which(.fixefNames %in% names(sd)) - 1L),
                  sd[names(sd) != ""],
                  rep_len(sd[names(sd) == ""], p - which(.fixefNames %in% names(sd))))
        } else {
          sd <- c(sd[1L], rep_len(sd[2L], p - 1L))
        }
        cov <- diag(sd, p)
      } else {
        if (length(sd) > p) warning("length of sd in normal prior exceeds number of fixed effects")
        
        sd.names <- names(sd)
        
        sd <- rep_len(sd, p)
        if (!is.null(sd.names)) {
          names(sd) <- rep_len(sd.names, p)
          ind <- match(.fixefNames, names(sd))
          ind[is.na(ind)] <- which(names(sd) %not_in% .fixefNames)
          sd <- sd[ind]
        }
        cov <- diag(sd, p)
      }
    }
    if (missing(cov) || is.null(cov)) {
      stop("normal prior requires either sd or cov to be specified")
    }
    if (length(cov) == p) {
      cov <- diag(cov, p)
    } else if (length(cov) != p * p) {
      stop("normal prior covariance of improper length")
    }

    if (any(cov != t(cov))) stop("normal covariance not symmetric")
    
    logDet <- determinant(cov, TRUE)
    if (logDet$sign < 0)
      stop("normal prior covariance negative semi-definite")
    if (is.infinite(logDet$modulus)) {
      if (any(cov[upper.tri(cov) | lower.tri(cov)] != 0))
        stop("normal prior covariance infinite")
      ## special case for diagonal scale matrices with infinite variances
      R.cov.inv <- diag(1 / sqrt(diag(cov)))
    } else {
      R.cov.inv <- solve(chol(cov))
    }
    
    new("bmerNormalDist", commonScale = common.scale, R.cov.inv = R.cov.inv)
  },
  t = function(df = 3, mean = 0, scale = c(10^2, 2.5^2), common.scale = TRUE) {
    matchedCall <- match.call()
    if (!is.null(matchedCall$df)) df <- eval(matchedCall$df)
    if (!is.null(matchedCall$mean)) mean <- eval(matchedCall$mean)
    if (!is.null(matchedCall$scale)) scale <- eval(matchedCall$scale)
    common.scale <- blme:::deparseCommonScale(common.scale)

    if (df <= 0) stop("t prior requires positive degrees of freedom")
    
    if (length(mean) == 1L) {
      mean <- rep_len(mean, p)
    } else if (length(mean) == 2L && p > 1L) {
      mean <- c(mean[1L], rep_len(mean[2L], p - 1L))
    } else if (length(mean) != p) {
      stop("t prior mean of improper length")
    }
    
    if (length(scale) == 1L) {
      scale <- diag(scale, p)
    } else if (length(scale) == 2L && p > 1L) {
      scale <- diag(c(scale[1L], rep_len(scale[2L], p - 1L)), p)
    } else if (length(scale) == p) {
      scale <- diag(scale, p)
    } else if (length(scale) != p * p) {
      stop("t prior scale of improper length")
    }
    
    if (any(scale != base::t(scale))) stop("t scale not symmetric")
    
    logDet <- determinant(scale, TRUE)
    if (logDet$sign < 0)
      stop("t prior scale negative semi-definite")
    if (is.infinite(logDet$modulus)) {
      if (any(scale[upper.tri(scale) | lower.tri(scale)] != 0))
        stop("t prior scale infinite")
      ## special case for diagonal scale matrices with infinite variances
      R.scale.inv <- diag(1 / sqrt(diag(scale)))
      d <- sum(is.finite(diag(scale)))
    } else {
      R.scale.inv <- solve(chol(scale))
      d <- nrow(R.scale.inv)
    }
    
    new("bmerTDist", commonScale = common.scale, df = df, beta.0 = mean, d = d, R.scale.inv = R.scale.inv)
  },
  horseshoe = function(mean = 0, global.shrinkage = 2.5, common.scale = TRUE) {
    matchedCall <- match.call()
    if (!is.null(matchedCall$mean)) mean <- eval(matchedCall$mean)
    if (!is.null(matchedCall$global.shrinkage)) global.shrinkage <- eval(matchedCall$global.shrinkage)
    common.scale <- blme:::deparseCommonScale(common.scale)
    
    if (length(mean) == 1L) {
      mean <- rep_len(mean, p)
    } else if (length(mean) == 2L && p > 1L) {
      mean <- c(mean[1L], rep_len(mean[2L], p - 1L))
    } else if (length(mean) != p) {
      stop("horseshoe prior mean of improper length")
    }
    
    if (global.shrinkage <= 0)
      stop("horseshoe prior global.shrinkage parameter must be positive")
    if (length(global.shrinkage) != 1L)
      stop("horseshoe prior global.shrinkage must be of length 1")
    
    new("bmerHorseshoeDist", beta.0 = mean, tau.sq = global.shrinkage^2, commonScale = common.scale)
  },
  gamma = function(shape = 2.5, rate = 0, common.scale = TRUE, posterior.scale = "sd") {
    matchedCall <- match.call()
    if (!is.null(matchedCall$shape)) shape <- eval(matchedCall$shape)
    if (!is.null(matchedCall$rate)) rate <- eval(matchedCall$rate)
    common.scale <- blme:::deparseCommonScale(common.scale)
    
    if (level.dim > 1L) {
      warning("gamma prior applied to multivariate grouping level will be ignored")
      return(NULL)
    }

    if (shape < 0) stop("gamma prior shape must be positive")
    if (rate  < 0) stop("gamma prior rate must be positive")

    new("bmerGammaDist", commonScale = common.scale, shape = shape, rate = rate, posteriorScale = posterior.scale)
  },
  invgamma = function(shape = 0.001, scale = shape + 0.05, common.scale = TRUE, posterior.scale = "var") {
    matchedCall <- match.call()
    if (!is.null(matchedCall$shape)) shape <- eval(matchedCall$shape)
    if (!is.null(matchedCall$scale)) scale <- eval(matchedCall$scale)
    common.scale <- blme:::deparseCommonScale(common.scale)
    
    if (level.dim > 1L) {
      warning("inverse gamma prior applied to multivariate grouping level will be ignored")
      return(NULL)
    }

    if (shape < 0) stop("invgamma prior shape must be positive")
    if (scale < 0) stop("invgamma prior scale must be positive")
    
    new("bmerInvGammaDist", commonScale = common.scale, shape = shape, scale = scale, posteriorScale = posterior.scale)
  },
  wishart = function(df = level.dim + 2.5, scale = Inf, common.scale = TRUE, posterior.scale = "cov") {
    matchedCall <- match.call()
    if (!is.null(matchedCall$df)) df <- eval(matchedCall$df)
    if (!is.null(matchedCall$scale)) scale <- eval(matchedCall$scale)
    common.scale <- blme:::deparseCommonScale(common.scale)
    
    if (df <= level.dim - 1L)
      stop("wishart dists for degrees of freedom less than or equal to (level.dim - 1) are singular or non-existent")
    
    log.det.scale <- NULL
    if (length(scale) == 1L) {
      if (is.infinite(scale)) {
        R.scale.inv <- diag(0, level.dim)
        log.det.scale <- Inf
      } else {
        if (scale[1L] < 0) stop("wishart prior scale negative definite")
        R.scale.inv <- diag(1 / sqrt(scale[1L]), level.dim)
      }
    } else if (length(scale) == level.dim) {
      if (any(scale < 0)) stop("wishart prior scale negative definite")
      R.scale.inv <- diag(1 / sqrt(scale), level.dim)
    } else if (length(scale) != level.dim * level.dim) {
      stop("wishart prior scale of improper length")
    } else {
      if (all(is.infinite(scale))) {
        R.scale.inv <- diag(0, level.dim)
        log.det.scale <- Inf
      }
      R.scale.inv <- solve(chol(scale))
    }
    if (is.null(log.det.scale)) {
      if (any(diag(R.scale.inv) < 0)) stop("wishart prior scale negative definite")
      
      if (any(is.infinite(diag(R.scale.inv))))
        log.det.scale <- Inf
      else
        log.det.scale <- -2.0 * sum(log(diag(R.scale.inv)))
    }

    new("bmerWishartDist", commonScale = common.scale, df = df, R.scale.inv = R.scale.inv,
        log.det.scale = log.det.scale,
        posteriorScale = posterior.scale)
  },
  invwishart = function(df = level.dim - 0.998, scale = diag(df + 0.1, level.dim),
                        common.scale = TRUE, posterior.scale = "cov") {
    matchedCall <- match.call()
    if (!is.null(matchedCall$df)) df <- eval(matchedCall$df)
    if (!is.null(matchedCall$scale)) scale <- eval(matchedCall$scale)
    common.scale <- blme:::deparseCommonScale(common.scale)

    if (df <= level.dim - 1L)
      stop("inverse wishart dists for degrees of freedom less than or equal to (level.dim - 1) are singular or non-existent")

    log.det.scale <- NULL
    if (length(scale) == 1L) {
      if (scale == 0) {
        R.scale <- diag(0, level.dim)
        log.det.scale <- -Inf
      } else {
        if (scale[1L] < 0) stop("inverse wishart prior scale negative definite")
        R.scale <- diag(sqrt(scale[1L]), level.dim)
      }
    } else if (length(scale) == level.dim) {
      if (any(scale < 0)) stop("inverse wishart prior scale negative definite")
      R.scale <- diag(sqrt(scale), level.dim)
    } else if (length(scale) != level.dim * level.dim) {
      stop("inverse wishart prior scale of improper length")
    } else {
      if (all(scale == 0)) {
        R.scale <- diag(0, level.dim)
        log.det.scale <- -Inf
      }
      R.scale <- chol(scale)
    }
    if (is.null(log.det.scale)) {
      if (any(diag(R.scale) < 0)) stop("inverse wishart prior scale negative definite")
      
      if (any(diag(R.scale) == 0))
        log.det.scale <- -Inf
      else
        log.det.scale <- 2.0 * sum(log(diag(R.scale)))
    }

    new("bmerInvWishartDist", commonScale = common.scale, df = df, R.scale = R.scale,
        log.det.scale = log.det.scale,
        posteriorScale = posterior.scale)
  },
  point = function(value = 1.0, posterior.scale = "sd") {
    matchedCall <- match.call()
    if (!is.null(matchedCall$value)) value <- eval(matchedCall$value)

    if (!(posterior.scale %in% c("sd", "var")))
      stop("point prior scale '", posterior.scale, "' unrecognized")

    if (posterior.scale == "var") value <- sqrt(value)

    if (value <= 0) stop("residual variance must be positive")
    
    new("bmerPointDist", commonScale = FALSE, value = value)
  },
  custom = function(fn, chol = FALSE, common.scale = TRUE, scale = "none") {
    matchedCall <- match.call()
    
    if (!is.null(matchedCall$chol)) chol <- eval(matchedCall$chol)
    if (!is.null(matchedCall$scale)) scale <- eval(matchedCall$scale)
    common.scale <- blme:::deparseCommonScale(common.scale)

    new("bmerCustomDist", fnName = matchedCall$fn, fn = fn,
        chol = chol, scale = scale, commonScale = common.scale)
  }
)

## closure out the common scale param
glmmDistributions <- list(
  flat = lmmDistributions$flat,
  normal = function(sd = c(10, 2.5), cov) {
    .prior <- blme:::lmmDistributions$normal
    environment(.prior) <- environment()
    
    matchedCall <- match.call()
    if (!is.null(matchedCall$sd) && !is.null(matchedCall$cov))
      warning("both sd and cov supplied to normal - only cov will be used")
    if (!is.null(matchedCall$cov)) {
      eval(substitute(.prior(cov = cov, common.scale = FALSE), environment()),
           parent.frame())
    } else {
      eval(substitute(.prior(sd = sd, common.scale = FALSE), environment()),
           parent.frame())
    }
  },
  t = function(df = 3, mean = 0, scale = c(10^2, 2.5^2)) {
    .prior <- blme:::lmmDistributions$t
    environment(.prior) <- environment()
    
    eval(substitute(.prior(df, mean, scale, FALSE), environment()),
         parent.frame()) 
  },
  horseshoe = function(mean = 0, global.shrinkage = 2.5) {
    .prior <- blme:::lmmDistributions$horseshoe
    environment(.prior) <- environment()
    
    eval(substitute(.prior(mean, global.shrinkage, FALSE), environment()),
         parent.frame()) 
  },
  gamma = function(shape = 2.5, rate = 0, posterior.scale = "sd") {
    .prior <- blme:::lmmDistributions$gamma
    environment(.prior) <- environment()
    
    eval(substitute(.prior(shape, rate, TRUE, posterior.scale), environment()),
         parent.frame()) 
  },
  invgamma = function(shape = 0.5, scale = 10^2, posterior.scale = "sd") {
    .prior <- blme:::lmmDistributions$invgamma
    environment(.prior) <- environment()
    eval(substitute(.prior(shape, scale, TRUE, posterior.scale), environment()),
         parent.frame())
  },
  wishart = function(df = level.dim + 2.5, scale = Inf, posterior.scale = "cov") {
    .prior <- blme:::lmmDistributions$wishart
    environment(.prior) <- environment()
    
    eval(substitute(.prior(df, scale, TRUE, posterior.scale), environment()),
         parent.frame())
  },
  invwishart = function(df = level.dim - 0.5, scale = diag(10^2 / (df + level.dim + 1), level.dim),
                        posterior.scale = "cov") {
    .prior <- blme:::lmmDistributions$invwishart
    environment(.prior) <- environment()
    eval(substitute(.prior(df, scale, TRUE, posterior.scale), environment()),
         parent.frame())
  },
  custom = function(fn, chol = FALSE, scale = "none") {
    .prior <- blme:::lmmDistributions$custom
    environment(.prior) <- environment()
    eval(substitute(.prior(fn, chol, scale), environment()),
         parent.frame())
  }
)

residualVarianceGammaPrior <- function(shape = 0, rate = 0, posterior.scale = "var") {
  matchedCall <- match.call()
  if (!is.null(matchedCall$shape)) shape <- eval(matchedCall$shape)
  if (!is.null(matchedCall$rate)) rate <- eval(matchedCall$rate)

  if (shape < 0) stop("gamma prior shape must be positive")
  if (rate  < 0) stop("gamma prior rate must be positive")
  
  new("bmerGammaDist", commonScale = FALSE, shape = shape, rate = rate, posteriorScale = posterior.scale)
}

residualVarianceInvGammaPrior <- function(shape = 0, scale = 0, posterior.scale = "var") {
  matchedCall <- match.call()
  if (!is.null(matchedCall$shape)) shape <- eval(matchedCall$shape)
  if (!is.null(matchedCall$scale)) scale <- eval(matchedCall$scale)

  if (shape < 0) stop("invgamma prior shape must be positive")
  if (scale < 0) stop("invgamma prior scale must be positive")
  
  new("bmerInvGammaDist", commonScale = FALSE, shape = shape, scale = scale, posteriorScale = posterior.scale)
}


## rather annoying problem of legacy interface allowing character strings of "true" or
## what not
deparseCommonScale <- function(common.scale) {
  if (is.null(common.scale)) return(TRUE)
  if (is.character(common.scale)) {
    if (common.scale == "TRUE" || common.scale == "true") return(TRUE)
    if (common.scale == "FALSE" || common.scale == "false") return(FALSE)
    return(eval(parse(text = common.scale)[[1L]]))
  }

  common.scale
}

context("bglmer numerical results with fixef and cov priors")

source(system.file("common", "glmmData.R", package = "blme"))
control <- glmerControl(optimizer = "Nelder_Mead")
lme4Version <- packageVersion("lme4")

test_that("bglmer fits test data with fixef prior, matching previous version", {
  fit <- bglmer(y ~ x.1 + x.2 + (1 | g), testData, family = binomial(), control = control,
                cov.prior = NULL, fixef.prior = normal)
  if (lme4Version < "1.1-4") {
    expect_equal(fit@theta, 1.26501253837861)
    expect_equal(fit@beta, c(0.873121247636467, 2.46647249930796, 1.32070156863358))
  } else {
    expect_equal(fit@theta, 1.26501385482573)
    expect_equal(fit@beta, c(0.873131216784199, 2.46647899095567, 1.32070496549675))
  }
})

test_that("bglmer fits test data with cov prior, matching previous version", {
  fit <- bglmer(y ~ x.1 + x.2 + (1 | g), testData, family = binomial(), control = control,
                cov.prior = wishart)
  if (lme4Version < "1.1-4") {
    expect_equal(fit@theta, 2.96766525351892)
    expect_equal(fit@beta, c(1.0963789854971, 3.67790570859986, 1.75655010020603))
  } else {
    expect_equal(fit@theta, 2.96767284827046)
    expect_equal(fit@beta, c(1.0963789854971, 3.67790570859986, 1.75655010020603))
  }
})

test_that("bglmer runs with fixef horseshoe prior", {
  suppressWarnings(fit <- bglmer(y ~ x.1 + x.2 + (1 | g), testData, family = binomial(), control = control,
                                 cov.prior = NULL, fixef.prior = horseshoe))
  
  expect_equal(fit@theta, 1.44188949480559)
  expect_equal(fit@beta, c(-3.00402517816968e-08, 2.38133218752372, 1.40658715296947))
})

test_that("bglmer runs cov prior specified using level.dim", {
  fit <- bglmer(y ~ x.1 + x.2 + (1 | g), testData, family = binomial(), control = control,
                cov.prior = wishart(df = level.dim + 1.25))
  expect_is(fit, "bglmerMod")
  expect_equal(fit@priors$cov[[1]]@df, 2.25)
})

## "parInfo" is a named list, each member also being a list containing
##   length
##   default - function of rho, aka the environment of the dev fun
##   lower   - lower bounds for par

## the order of elements in it is the order that they are passed to the optimizer
## not that that should matter to a downstream user. if they care, construct it by
## index

## for models with a single parameter vector, the name "theta" is sufficient
## so we can return without further analysis
expandParsInCurrentFrame <- function(parVector, parInfo) {
  if (length(parInfo) == 1) return(invisible(NULL))
  
  parentEnv <- parent.frame()
  parNames <- names(parInfo)
  
  index <- 0
  for (i in 1:length(parInfo)) {
    parLength <- parInfo[[i]]$length
    parName <- parNames[[i]]

    parentEnv[[parName]] <- parVector[index + 1:parLength]
    index <- index + parLength
  }
  invisible(NULL)
}

getStartingValues <- function(userStart, devFunEnv, parInfo) {
  if (is.null(userStart)) userStart <- list()
  if (is.numeric(userStart)) userStart <- list(theta = userStart)
  if (is.list(userStart) && length(userStart) == 1 &&
      is.null(names(userStart))) names(userStart) <- "theta"
  
  invalidStartingValues <- !(names(userStart) %in% names(parInfo))
  if (any(invalidStartingValues))
    warning("starting values for parameter(s) '", toString(names(userStart)[invalidStartingValues]),
            "' not part of model and will be ignored")

  start <- numeric(sum(sapply(parInfo, function(par.i) par.i$length)))
  offset <- 0L
  for (i in 1:length(parInfo)) {
    parName <- names(parInfo)[[i]]
    parLength <- parInfo[[i]]$length

    userValue <- userStart[[parName]]
    useDefault <- TRUE
    if (!is.null(userValue)) {
      if (length(userValue) != parLength) {
        warning("parameter '", parName, "' is of length ", parLength, ", yet supplied vector is of length ",
                length(userValue), ". start will be ignored")
      } else {
        start[offset + 1:parLength] <- userValue
        useDefault <- FALSE
      }
    }
    if (useDefault)
      start[offset + 1:parLength] <- parInfo[[i]]$default(devFunEnv)
    
    offset <- offset + parLength
  }
  start
}

extractParameterListFromFit <- function(fit, blmerControl) {
  result <- list(theta = fit@theta)
  if (blmerControl$fixefOptimizationType == FIXEF_OPTIM_NUMERIC) {
    if (fit@devcomp$dims[["GLMM"]] != 0L)
      result$fixef <- fit@beta
    else
      result$beta  <- fit@beta
  }
  if (fit@devcomp$dims[["GLMM"]] == 0L && blmerControl$fixefOptimizationType == SIGMA_OPTIM_NUMERIC) {
    result$sigma <- if (fit@devcomp$dims[["REML"]] == 0L) fit@devcomp$cmp[["sigmaML"]] else fit@devcomp$cmp[["sigmaREML"]]
  }
  result
}

getLowerBounds <- function(parInfo) {
  result <- numeric(sum(sapply(parInfo, function(par.i) par.i$length)))
  offset <- 0L
  for (i in 1:length(parInfo)) {
    parName <- names(parInfo)[[i]]
    parLength <- parInfo[[i]]$length
    parLower <- parInfo[[i]]$lower
    if (parLength != length(parLower)) stop("length of lower bounds for parameter '", parName, "' does not equal length of vector")

    result[offset + 1:parLength] <- parLower
    offset <- offset + parLength
  }
  
  result
}

getParInfo <- function(pred, resp, ranefStructure, blmerControl) {
  numPars <- 1
  result <- list(theta = list(length = ranefStructure$numCovParameters,
                   lower = ranefStructure$lower,
                   default = function(devFunEnv) pred$theta))
  
  if (blmerControl$fixefOptimizationType == FIXEF_OPTIM_NUMERIC) {
    numPars <- numPars + 1
    numFixef <- if (length(pred$X) > 0) ncol(pred$X) else 0
    result[[numPars]] <-
      list(length = numFixef,
             lower = rep(-Inf, numFixef),
             default = function(devFunEnv) pred$beta0 + pred$delb)
    names(result)[[numPars]] <- "beta"
  }
  if (blmerControl$sigmaOptimizationType == SIGMA_OPTIM_NUMERIC) {
    numPars <- numPars + 1
    result[[numPars]] <-
      list(length = 1L,
             lower = 0,
             default = function(devFunEnv) sd(resp$y))
    names(result)[[numPars]] <- "sigma"
  }
  
  result
}

getCovBlocks <- function(cov, ranefStructure) {
  index <- 0
  result <- list()
  for (i in 1:ranefStructure$numFactors) {
    result[[i]] <- as.matrix(cov[index + 1:ranefStructure$numCoefPerFactor[i],
                                 index + 1:ranefStructure$numCoefPerFactor[i]])
    index <- index + ranefStructure$numRanefPerFactor[i]
  }

  return(result)
}

## from lme4
namedList <- function(...) {
  result <- list(...)
  substituteNames <- sapply(substitute(list(...)), deparse)[-1]
  if (is.null(resultNames <- names(result))) resultNames <- substituteNames
  if (any(noNames <- resultNames == "")) resultNames[noNames] <- substituteNames[noNames]
  setNames(result, resultNames)
}

is.formula <- function(term) is.language(term) && term[[1]] == '~'

#quoteInNamespace <- function(name, character.only = FALSE) {
#  result <- quote(a + b)
#  result[[1]] <- as.symbol(":::")
#  result[[2]] <- as.symbol("blme")
#  
#  result[[3]] <- if (character.only) name else match.call()[[2]]
#  result
#}

"%not_in%" <- function(x, table) match(x, table, nomatch = 0L) <= 0L

## copyright note:
##   a lot of of this was copy/pasted from the lme4 package (http://cran.r-project.org/web/packages/lme4/index.html, GPL-2)
##   a lot of it was not
## ideally, blme wouldn't have to recreate the functions with minor tweaks but we're just not there yet

## for R-check
wishart <- "ignored"

blmer <- function(formula, data = NULL, REML = TRUE,
                  control = lmerControl(), start = NULL,
                  verbose = 0L, subset, weights, na.action, offset,
                  contrasts = NULL, devFunOnly = FALSE,
                  cov.prior = wishart, fixef.prior = NULL,
                  resid.prior = NULL,
                  ...)
{
  mc <- mcout <- match.call()
  callingEnv <- parent.frame(1L)
  missCtrl <- missing(control)
  missCovPrior <- missing(cov.prior)
  ## see functions in modular.R for the body ...
  if (!missCtrl && !inherits(control, "lmerControl")) {
    if(!is.list(control)) stop("'control' is not a list; use lmerControl()")
    ## back-compatibility kluge
    warning("passing control as list is deprecated: please use lmerControl() instead",
            immediate.=TRUE)
    control <- do.call(lmerControl, control)
  }
  if (!is.null(list(...)[["family"]])) {
    warning("calling lmer with 'family' is deprecated; please use glmer() instead")
    mc[[1]] <- quote(lme4::glmer)
    if(missCtrl) mc$control <- glmerControl()
    return(eval(mc, parent.frame(1L)))
  }
  
  fixef.prior <- mc$fixef.prior ## for delayed evaluation, get quoted versions
  cov.prior <- if (!missCovPrior) mc$cov.prior else formals(blmer)$cov.prior
  resid.prior <- mc$resid.prior
  if (!is.null(mc$var.prior)) resid.prior <- parse(text = mc$var.prior)[[1]]
  mc$fixef.prior <- NULL
  mc$cov.prior <- NULL
  mc$resid.prior <- NULL
  mc$var.prior <- NULL
  
  sigmaIsFixed <-
    !is.null(resid.prior) && ((is.character(resid.prior) && grepl("^\\W*point", resid.prior)) ||
                              (is.call(resid.prior) && resid.prior[[1]] == "point"))
  
  if (sigmaIsFixed) {
    control$checkControl$check.nobs.vs.nlev  <- "ignore"
    control$checkControl$check.nobs.vs.rankZ <- "ignore"
    control$checkControl$check.nobs.vs.nRE   <- "ignore"
  }

  hasPseudoData <-
    !is.null(fixef.prior) && ((is.character(fixef.prior) && grepl("^\\W*normal", fixef.prior)) ||
                              (is.call(fixef.prior) && fixef.prior[[1]] == "normal"))

  if (hasPseudoData) {
    control$checkControl$check.rankX <- "ignore"
  }
  
  mc$control <- control ## update for  back-compatibility kluge
  
  ## https://github.com/lme4/lme4/issues/50
  ## parse data and formula
  mc[[1]] <- quote(lme4::lFormula)
  lmod <- eval(mc, parent.frame(1L))
  mcout$formula <- lmod$formula
  lmod$formula <- NULL

  ## peel off the starting values lmer stuff expects to see
  lmerStart <- NULL
  if (!is.null(start) && is.list(start) && length(start) > 1)
    lmerStart <- start$theta
  devfun <- do.call(mkBlmerDevfun,
                    c(lmod, lmod$X, lmod$reTrms,
                      list(priors = list(covPriors = cov.prior, fixefPrior = fixef.prior, residPrior = resid.prior),
                           start = lmerStart, verbose = verbose, control = control, env = callingEnv)))
  
  if (devFunOnly) return(devfun)
  
  devFunEnv <- environment(devfun)
  opt <- if (control$optimizer=="none")
    list(par=NA,fval=NA,conv=1000,message="no optimization")
  else {
        optimizeLmer(devfun, optimizer = control$optimizer,
                     restart_edge = control$restart_edge,
                     boundary.tol = control$boundary.tol,
                     control = control$optCtrl,
                     verbose=verbose,
                     start=start,
                     calc.derivs=control$calc.derivs,
                     use.last.params=control$use.last.params)
  }
  
  ## dirty hacks to give some backwards lme4 compatibility
  cc <- NULL
  lme4Namespace <- getNamespace("lme4")
  if (exists("checkConv", lme4Namespace)) {
    checkConv <- get("checkConv", lme4Namespace)
    cc <- checkConv(attr(opt, "derivs"), opt$par,
                    ctrl = control$checkConv,
                    lbound = environment(devfun)$lower)
  }

  args <- list(rho = devFunEnv, opt = opt, reTrms = lmod$reTrms, fr = lmod$fr, mc = mcout)
  if ("lme4conv" %in% names(formals(mkMerMod))) args$lme4conv <- cc
  result <- do.call(mkMerMod, args, TRUE)
  result <- repackageMerMod(result, opt, devFunEnv)
  
  return(result)
}

bglmer <- function(formula, data = NULL, family = gaussian,
                   control = glmerControl(), start = NULL, verbose = 0L, nAGQ = 1L,
                   subset, weights, na.action, offset,
                   contrasts = NULL, mustart, etastart, devFunOnly = FALSE,
                   cov.prior = wishart, fixef.prior = NULL,
                   ...)
{
  covPriorMissing <- missing(cov.prior)
  callingEnv <- parent.frame(1L)
  
  if (!inherits(control, "glmerControl")) {
    if(!is.list(control)) stop("'control' is not a list; use glmerControl()")
    ## back-compatibility kluge
    msg <- "Use control=glmerControl(..) instead of passing a list"
    if(length(cl <- class(control))) msg <- paste(msg, "of class", dQuote(cl[1]))
    warning(msg, immediate.=TRUE)
    control <- do.call(glmerControl, control)
  }
  mc <- mcout <- match.call()
  
  fixef.prior <- mc$fixef.prior ## for delayed evaluation, store as quoted
  cov.prior <- if (!covPriorMissing) mc$cov.prior else formals(bglmer)$cov.prior
  mc$fixef.prior <- NULL
  mc$cov.prior <- NULL
  
  ## family-checking code duplicated here and in glFormula (for now) since
  ## we really need to redirect at this point; eventually deprecate formally
  ## and clean up
 if (is.character(family))
   family <- get(family, mode = "function", envir = parent.frame(2))
  if( is.function(family)) family <- family()
  if (isTRUE(all.equal(family, gaussian()))) {
    ## redirect to lmer (with warning)
    warning("calling bglmer() with family=gaussian (identity link) as a shortcut to blmer() is deprecated;",
            " please call blmer() directly")
    mc[[1]] <- quote(blme::blmer)
    mc["family"] <- NULL            # to avoid an infinite loop
    return(eval(mc, parent.frame()))
  }
  
  ## see https://github.com/lme4/lme4/issues/50
  ## parse the formula and data
  mc[[1]] <- quote(lme4::glFormula)
  glmod <- eval(mc, parent.frame(1L))
  mcout$formula <- glmod$formula
  glmod$formula <- NULL
  
  ## create deviance function for covariance parameters (theta)
  nAGQinit <- if(control$nAGQ0initStep) 0L else 1L
  devfun <- do.call(mkBglmerDevfun, c(glmod,
                                      list(priors = list(covPriors = cov.prior, fixefPrior = fixef.prior),
                                           verbose = verbose,
                                           control = control,
                                           nAGQ = nAGQinit,
                                           env = callingEnv)))
  if (nAGQ==0 && devFunOnly) return(devfun)
  ## optimize deviance function over covariance parameters
  
  ## FIXME: perhaps should be in glFormula instead??
  if (is.list(start)) {
    start.bad <- setdiff(names(start),c("theta","fixef"))
    if (length(start.bad)>0) {
      stop(sprintf("bad name(s) for start vector (%s); should be %s and/or %s",
                   paste(start.bad,collapse=", "),
                   shQuote("theta"),
                   shQuote("fixef")),call.=FALSE)
    }
    if (!is.null(start$fixef) && nAGQ==0)
      stop("should not specify both start$fixef and nAGQ==0")
  }
  
  if (packageVersion("lme4") <= "1.1-7" || identical(control$nAGQ0initStep, TRUE)) {
    args <- list(devfun = devfun,
                 optimizer = control$optimizer[[1]],
                 ## DON'T try fancy edge tricks unless nAGQ=0 explicitly set
                 restart_edge = if (nAGQ == 0) control$restart_edge else FALSE,
                 control = control$optCtrl,
                 start = start,
                 nAGQ = 0,
                 verbose = verbose)
    if (!is.null(formals(optimizeGlmer)$boundary.tol)) args$boundary.tol <- if (nAGQ == 0) control$boundary.tol else 0
    if (!is.null(formals(optimizeGlmer)[["..."]])) args$calc.derivs <- FALSE
    
    opt <- do.call(optimizeGlmer, args, TRUE)
  }
  
  if(nAGQ > 0L) {
    start <- get("updateStart", getNamespace("lme4"))(start,theta=opt$par)
    
    ## update deviance function to include fixed effects as inputs
    devfun <- updateBglmerDevfun(devfun, glmod$reTrms, nAGQ = nAGQ)
    
    if (devFunOnly) return(devfun)
    ## reoptimize deviance function over covariance parameters and fixed effects 
    args <- list(devfun = devfun,
                 optimizer = control$optimizer[[2]],
                 restart_edge = control$restart_edge,
		 control = control$optCtrl,
                 start = start,
                 nAGQ = nAGQ,
                 verbose = verbose,
                 stage = 2)
    if (!is.null(formals(optimizeGlmer)$boundary.tol)) args$boundary.tol <- control$boundary.tol
    if (!is.null(formals(optimizeGlmer)[["..."]])) {
      args$calc.derivs <- control$calc.derivs
      args$use.last.params <- control$use.last.params
    }
    ## reoptimize deviance function over covariance parameters and fixed effects
    opt <- do.call(optimizeGlmer, args, TRUE)
  }

  lme4Namespace <- getNamespace("lme4")
  cc <- if (!is.null(control$calc.derivs) && !control$calc.derivs) NULL else {
    if (exists("checkConv", lme4Namespace)) {
      if (verbose > 10) cat("checking convergence\n")
      checkConv <- get("checkConv", lme4Namespace)
      checkConv(attr(opt,"derivs"), opt$par,
                ctrl = control$checkConv,
                lbound = environment(devfun)$lower)
    }
    else NULL
  }
  
  ## prepare output
  args <- list(rho = environment(devfun), opt = opt, reTrms = glmod$reTrms, fr = glmod$fr, mc = mcout)
  if ("lme4conv" %in% names(formals(mkMerMod))) args$lme4conv <- cc
  result <- do.call(mkMerMod, args, TRUE)
  result <- repackageMerMod(result, opt, environment(devfun))
  
  return(result)
}

lmmObjective <- function(pp, resp, sigma, exponentialTerms, polynomialTerm, blmerControl) {
  sigma.sq <- sigma^2
  result <- resp$objective(pp$ldL2(), pp$ldRX2(), pp$sqrL(1.0), sigma.sq)

  exponentialTerm <- 0
  for (i in seq_along(exponentialTerms)) {
    power <- as.numeric(names(exponentialTerms)[[i]])
    value <- exponentialTerms[[i]]
    if (!is.finite(value)) return(value)
    
    exponentialTerm <- exponentialTerm + value * sigma^power
  }

  priorPenalty <- exponentialTerm + polynomialTerm + blmerControl$constant + blmerControl$df * log(sigma.sq)
  
  result <- result + priorPenalty

  return(result)
}

repackageMerMod <- function(merMod, opt, devFunEnv) {
  isLMM <- is(merMod, "lmerMod")

  blmerControl <- devFunEnv$blmerControl
  priors <- devFunEnv$priors
  
  sigma <- NULL
  if (isLMM) {
    expandParsInCurrentFrame(opt$par, devFunEnv$parInfo)
    if (blmerControl$fixefOptimizationType != FIXEF_OPTIM_NUMERIC) beta <- merMod@pp$beta(1.0)
    else merMod@beta <- beta
    
    if (blmerControl$sigmaOptimizationType == SIGMA_OPTIM_POINT) sigma <- priors$residPrior@value
  } else {
    beta <- opt$par[-devFunEnv$dpars]
  }
  
  if (!is.null(merMod@optinfo)) {
    parLength <- devFunEnv$parInfo$theta$length + if (!isLMM) devFunEnv$parInfo$beta$length else 0
    if (parLength != length(merMod@optinfo$val)) {
      merMod@optinfo$val_full    <- merMod@optinfo$val
      merMod@optinfo$derivs_full <- merMod@optinfo$derivs
      
      merMod@optinfo$val <- merMod@optinfo$val[parLength]
      merMod@optinfo$derivs$gradient <- merMod@optinfo$derivs$gradient[parLength]
      merMod@optinfo$derivs$Hessian <- merMod@optinfo$derivs$Hessian[parLength, parLength, drop = FALSE]
    }
  }
  
  Lambda.ts <- getCovBlocks(merMod@pp$Lambdat, devFunEnv$ranefStructure)
  exponentialTerms <- calculatePriorExponentialTerms(priors, beta, Lambda.ts, sigma)

  if (isLMM) {
    if (blmerControl$fixefOptimizationType == FIXEF_OPTIM_NUMERIC) {
      ## when beta can't be profiled, a term is added that is a weighted distance of the numeric optimum
      ## and a least-squares solution (what the merMod calculates)
      fixefExponentialTerm <- calculateFixefExponentialTerm(beta, merMod@pp$beta(1.0), merMod@pp$RX())
      if (is.null(exponentialTerms[["-2"]])) {
        exponentialTerms[["-2"]] <- fixefExponentialTerm
      } else {
        exponentialTerms[["-2"]] <- exponentialTerms[["-2"]] + fixefExponentialTerm
      }
    }

    if (!is.null(exponentialTerms[["-2"]]))
      merMod@devcomp$cmp[["pwrss"]] <- merMod@devcomp$cmp[["pwrss"]] + as.numeric(exponentialTerms[["-2"]])
  
    ## recover sigma
    sigmaOptimizationType <- blmerControl$sigmaOptimizationType
    if (sigmaOptimizationType %not_in% c(SIGMA_OPTIM_NA, SIGMA_OPTIM_POINT, SIGMA_OPTIM_NUMERIC)) {
      profileSigma <- getSigmaProfiler(priors, blmerControl)
      sigma <- profileSigma(merMod@pp, merMod@resp, exponentialTerms, blmerControl)
    }
    ## set sigma in final object
    numObs   <- merMod@devcomp$dims[["n"]]
    numFixef <- merMod@devcomp$dims[["p"]]
    if (merMod@devcomp$dims[["REML"]] > 0L) {
      merMod@devcomp$cmp[["sigmaREML"]] <- sigma
      merMod@devcomp$cmp[["sigmaML"]] <- sigma * sqrt((numObs - numFixef) / numObs)
    } else {
      merMod@devcomp$cmp[["sigmaML"]] <- sigma
      merMod@devcomp$cmp[["sigmaREML"]] <- sigma * sqrt(numObs / (numObs - numFixef))
    }

    
    objectiveValue <- merMod@resp$objective(merMod@pp$ldL2(), merMod@pp$ldRX2(), merMod@pp$sqrL(1.0), sigma^2)
    if (blmerControl$fixefOptimizationType == FIXEF_OPTIM_NUMERIC)
      objectiveValue <- objectiveValue + fixefExponentialTerm / sigma^2
    
    if (merMod@devcomp$dims[["REML"]] > 0L) {
      priorPenalty <- merMod@devcomp$cmp[["REML"]] - objectiveValue
      merMod@devcomp$cmp[["REML"]] <- objectiveValue
    } else {
      priorPenalty <- merMod@devcomp$cmp[["dev"]] - objectiveValue
      merMod@devcomp$cmp[["dev"]] <- objectiveValue
    }
    merMod@devcomp$cmp[["penalty"]] <- priorPenalty

    return(new("blmerMod",
               resp    = merMod@resp,
               Gp      = merMod@Gp,
               call    = merMod@call,
               frame   = merMod@frame,
               flist   = merMod@flist,
               cnms    = merMod@cnms,
               lower   = merMod@lower,
               theta   = merMod@theta,
               beta    = beta,
               u       = merMod@u,
               devcomp = merMod@devcomp,
               pp      = merMod@pp,
               optinfo = merMod@optinfo,
               priors  = priors))
  } else {
    if (length(exponentialTerms) > 0)
      priorPenalty <- exponentialTerms[[1]] + calculatePriorPolynomialTerm(priors$covPriors, Lambda.ts) + blmerControl$constant
    else
      priorPenalty <- 0
    merMod@devcomp$cmp[["dev"]] <- merMod@devcomp$cmp[["dev"]] - priorPenalty
    merMod@devcomp$cmp[["penalty"]] <- priorPenalty

    return(new("bglmerMod",
               resp    = merMod@resp,
               Gp      = merMod@Gp,
               call    = merMod@call,
               frame   = merMod@frame,
               flist   = merMod@flist,
               cnms    = merMod@cnms,
               lower   = merMod@lower,
               theta   = merMod@theta,
               beta    = merMod@beta,
               u       = merMod@u,
               devcomp = merMod@devcomp,
               pp      = merMod@pp,
               optinfo = merMod@optinfo,
               priors  = priors))
  }
}

validateRegressionArgument <- function(regression, regressionName) {
  if (missing(regression)) stop("'regression' missing.")
  
  # check for existence and null-ness
  if (is.null(regression)) stop("object '", regressionName, "' is null.")
  if (!is(regression, "bmerMod")) stop("object '", regressionName, "' does not inherit from S4 class 'bmerMod'.")
}

setPrior <- function(regression, cov.prior = NULL,
                     fixef.prior = NULL, resid.prior = NULL, envir = parent.frame(1L), ...)
{
  matchedCall <- match.call()

  covMissing   <- missing(cov.prior)
  fixefMissing <- missing(fixef.prior)
  residMissing <- missing(resid.prior)
  
  validateRegressionArgument(regression, matchedCall$regression)
  
  if (residMissing && !is.null(matchedCall$var.prior)) {
    matchedCall$resid.prior <- matchedCall$var.prior
    residMissing <- FALSE
  }
  
  priors <- evaluatePriorArguments(matchedCall$cov.prior, matchedCall$fixef.prior, matchedCall$resid.prior,
                                   regression@devcomp$dim, colnames(regression@pp$X), regression@cnms,
                                   as.integer(diff(regression@Gp) / sapply(regression@cnms, length)),
                                   envir)

  if (!covMissing) regression@covPriors <- priors$covPriors
  if (!fixefMissing) regression@fixefPrior <- priors$fixefPrior
  if (!residMissing) regression@residPrior <- priors$residPrior
  
  return (regression)
}

parsePrior <- function(regression, cov.prior = NULL,
                       fixef.prior = NULL, resid.prior = NULL, envir = parent.frame(), ...)
{
  matchedCall <- match.call()

  covMissing   <- missing(cov.prior)
  fixefMissing <- missing(fixef.prior)
  residMissing <- missing(resid.prior)
  
  validateRegressionArgument(regression, matchedCall$regression)
  
  if (residMissing && !is.null(matchedCall$var.prior)) {
    matchedCall$resid.prior <- matchedCall$var.prior
    residMissing <- FALSE
  }

  priors <- evaluatePriorArguments(matchedCall$cov.prior, matchedCall$fixef.prior, matchedCall$resid.prior,
                                   regression@devcomp$dim, colnames(regression@pp$X), regression@cnms,
                                   as.integer(diff(regression@Gp) / sapply(regression@cnms, length)),
                                   envir)

  result <- list()
  if (!covMissing) result$covPriors <- priors$covPriors
  if (!fixefMissing) result$fixefPrior <- priors$fixefPrior
  if (!residMissing) result$residPrior <- priors$residPrior

  if (length(result) == 1) return(result[[1]])
  return(result)
}

if (FALSE) {
runOptimizer <- function(regression, verbose = FALSE)
{
  validateRegressionArgument(regression, match.call()$regression)
  
  if (verbose) {
    regression@dims[["verb"]] <- as.integer(1)
  } else {
    regression@dims[["verb"]] <- as.integer(0)
  }
  return (mer_finalize(regression))
}

runOptimizerWithPrior <- function(regression, cov.prior = NULL,
                                  fixef.prior = NULL, var.prior = NULL,
                                  verbose = FALSE, envir = parent.frame())
{
  validateRegressionArgument(regression, match.call()$regression)
  
  regression <- setPrior(regression, cov.prior, fixef.prior, var.prior, envir)
  
  return(runOptimizer(regression, verbose))
}
}

refit.bmerMod <- function(object, newresp = NULL, rename.response = FALSE,
                          maxit = 100L, ...)
{
  lme4Namespace <- getNamespace("lme4")
  lme4Version   <- packageVersion("lme4")

  dotsList <- list(...)
  
  newControl <- NULL
  if ("control" %in% names(dotsList)) newControl <- dotsList$control
  
  if (!all(names(dotsList) %in% c("control", "verbose")))
    warning("additional arguments to refit.bmerMod ignored")
  
  ## TODO: not clear whether we should reset the names
  ##       to the new response variable.  Maybe not.
  
  ## retrieve name before it gets mangled by operations on newresp
  newrespSub <- substitute(newresp)
  
  ## for backward compatibility/functioning of refit(fit,simulate(fit))
  if (is.list(newresp)) {
    if (length(newresp) == 1) {
      na.action <- attr(newresp,"na.action")
      newresp <- newresp[[1]]
      attr(newresp, "na.action") <- na.action
    } else {
      stop("refit not implemented for lists with length > 1: ",
           "consider ", sQuote("lapply(object, refit)"))
    }
  }
    
  ## oldresp <- object@resp$y # need to set this before deep copy,
  ##                          # otherwise it gets reset with the call
  ##                          # to setResp below
  
  
  ## somewhat repeated from profile.merMod, but sufficiently
  ##  different that refactoring is slightly non-trivial
  ## "three minutes' thought would suffice ..."
  ignore.pars <- c("xst", "xt")
  control.internal <- object@optinfo$control
  if (length(ign <- which(names(control.internal) %in% ignore.pars)) > 0L)
    control.internal <- control.internal[-ign]
  if (!is.null(newControl)) {
    control <- newControl
    if (length(control$optCtrl) == 0L)
       control$optCtrl <- control.internal
  } else {
    control <- if (isGLMM(object)) glmerControl() else lmerControl()
  }
    
  ## we need this stuff defined before we call .glmerLaplace below ...
  pp        <- object@pp$copy()
  dc        <- object@devcomp
  nAGQ      <- unname(dc$dims["nAGQ"]) # possibly NA # blme change
  nth       <- dc$dims[["nth"]]
  verbose <- dotsList$verbose; if (is.null(verbose)) verbose <- 0L
  if (!is.null(newresp)) {
    ## update call and model frame with new response
    rcol <- attr(attr(model.frame(object), "terms"), "response")
    if (rename.response) {
      attr(object@frame,"formula")[[2L]] <- object@call$formula[[2L]] <- newrespSub
      names(object@frame)[rcol] <- deparse(newrespSub)
    }
    if (!is.null(na.act <- attr(object@frame,"na.action")) &&
        is.null(attr(newresp, "na.action"))) {
      ## will only get here if na.action is 'na.omit' or 'na.exclude'
      ## *and* newresp does not have an 'na.action' attribute
      ## indicating that NAs have already been filtered
      newresp <- if (is.matrix(newresp))
        newresp[-na.act, ]
      else newresp[-na.act]
    }
    object@frame[,rcol] <- newresp
    
    ## modFrame <- model.frame(object)
    ## modFrame[, attr(terms(modFrame), "response")] <- newresp
  }
  
  rr <- if (isLMM(object))
    mkRespMod(model.frame(object), REML = isREML(object))
  else if (isGLMM(object)) {
    modelFrame <- model.frame(object) ## blme change
    if (lme4Version <= "1.1-6") modelFrame$mustart <- object@resp$mu
    mkRespMod(modelFrame, family = family(object))
  } else
    stop("refit.bmerMod not working for nonlinear mixed models")
  
  if (!is.null(newresp)) {
    if (family(object)$family == "binomial") {
      ## re-do conversion of two-column matrix and factor
      ##  responses to proportion/weights format
      if (is.matrix(newresp) && ncol(newresp) == 2) {
        ntot <- rowSums(newresp)
        ## FIXME: test what happens for (0,0) rows
        newresp <- newresp[,1] / ntot
        rr$setWeights(ntot)
      }
      if (is.factor(newresp)) {
        ## FIXME: would be better to do this consistently with
        ## whatever machinery is used in glm/glm.fit/glmer ... ??
        newresp <- as.numeric(newresp) - 1
      }
    }
    
    ## if (isGLMM(object) && rr$family$family=="binomial") {
    ## }
    stopifnot(length(newresp <- as.numeric(as.vector(newresp))) ==
              length(rr$y))
    
  }
  
  ## hacking around to try to get internals properly set up
  ##  for refitting.  This helps, but not all the way ...
  ## oldresp <- rr$y # set this above from before copy
  ## rr$setResp(newresp)
  ## rr$setResp(oldresp)
  ## rr$setResp(newresp)
  glmerPwrssUpdate <- get("glmerPwrssUpdate", lme4Namespace)
  if (isGLMM(object)) {
    GQmat <- GHrule(nAGQ)
    if (nAGQ <= 1) {
      if (lme4Version <= "1.1-7")
        glmerPwrssUpdate(pp, rr, control$tolPwrss, GQmat)
      else
        glmerPwrssUpdate(pp, rr, control$tolPwrss, GQmat, maxit = maxit)
    } else {
      if (lme4Version <= "1.1-7")
        glmerPwrssUpdate(pp, rr, control$tolPwrss, GQmat, grpFac = object@flist[[1]])
      else
        glmerPwrssUpdate(pp, rr, control$tolPwrss, GQmat, maxit = maxit, grpFac = object@flist[[1]])
    }
    
    baseOffset <- object@resp$offset
  }
  ## .Call(glmerLaplace, pp$ptr(), rr$ptr(), nAGQ,
  ## control$tolPwrss, as.integer(30), verbose)
  ##              nAGQ,
  ##              control$tolPwrss, as.integer(30), # maxit = 30
  ##              verbose)
  ##        lp0         <- pp$linPred(1) # each pwrss opt begins at this eta

  devlist <- if (isGLMM(object))
    list(tolPwrss    = dc$cmp [["tolPwrss"]],
	 compDev     = dc$dims[["compDev"]],
	 nAGQ        = unname(nAGQ),
	 lp0         = pp$linPred(1), ## object@resp$eta - baseOffset,
	 baseOffset  = baseOffset,
	 pwrssUpdate = glmerPwrssUpdate,
	 ## save GQmat in the object and use that instead of nAGQ
	 GQmat       = GHrule(nAGQ),
	 fac         = object@flist[[1]],
	 pp          = pp,
         resp        = rr,
         u0          = pp$u0,
         verbose     = verbose,
         dpars       = seq_len(nth))
  else
    list(pp      = pp,
         resp    = rr,
         u0      = pp$u0,
         verbose = verbose,
         dpars   = seq_len(nth))
  
  ## blme changes
  ff <- makeRefitDevFun(list2env(devlist), nAGQ = nAGQ, verbose = verbose, maxit = maxit, object = object)
  reTrms <- list(flist = object@flist, cnms = object@cnms, Gp = object@Gp, lower = object@lower)
  if (isGLMM(object))
    ff <- updateBglmerDevfun(ff, reTrms, nAGQ)
  
  
  ## commenting out xst (not used) and x0, which we grab elsewhere
  ## xst       <- rep.int(0.1, nth)
  ## x0        <- pp$theta
  ## lower     <- object@lower
  lower <- environment(ff)$lower
  ## if (!is.na(nAGQ) && nAGQ > 0L) {
  ##    xst   <- c(xst, sqrt(diag(pp$unsc())))
  ##    x0    <- c(x0, unname(fixef(object)))
  ##     lower <- c(lower, rep(-Inf, length(x0) - length(lower)))
  ##}
  
  ## blme end
  
  ## control <- c(control, list(xst = 0.2 * xst, xt = xst * 0.0001))
  ## FIX ME: allow use.last.params to be passed through
  calc.derivs <- !is.null(object@optinfo$derivs)
  ## if (isGLMM(object)) {
  ##   rho$resp$updateWts()
  ##   rho$pp$updateDecomp()
  ##   rho$lp0 <- rho$pp$linPred(1)
  ## }
  
  ## blme changes below
  opt <-
    if (isLMM(object)) {
      optimizeLmer(ff,
                   optimizer = object@optinfo$optimizer,
                   control = control$optCtrl,
                   verbose = verbose,
                   start = extractParameterListFromFit(object, environment(ff)$blmerControl),
                   calc.derivs = calc.derivs,
                   use.last.params = if (!is.null(control$use.last.params)) control$use.last.params else FALSE)
    } else {
      args <- list(devfun = ff,
                   optimizer = object@optinfo$optimizer,
                   restart_edge = control$restart_edge,
                   control = control$optCtrl,
                   start = extractParameterListFromFit(object, environment(ff)$blmerControl),
                   nAGQ = nAGQ,
                   verbose = verbose,
                   stage = 2)
      if (!is.null(formals(optimizeGlmer)$boundary.tol)) args$boundary.tol <- control$boundary.tol
      if (!is.null(formals(optimizeGlmer)[["..."]])) {
        args$calc.derivs <- control$calc.derivs
        args$use.last.params <- if (!is.null(control$use.last.params)) control$use.last.params else FALSE
      }
      do.call(optimizeGlmer, args, TRUE)
    }
  cc <- NULL
  if (exists("checkConv", lme4Namespace)) {
    cc <- get("checkConv", lme4Namespace)(attr(opt,"derivs"), opt$par,
                                          ctrl = control$checkConv,
                                          lbound = lower)
  }
  
  if (isGLMM(object)) rr$setOffset(baseOffset)
  
  args <- list(rho = environment(ff), opt = opt,
               reTrms = reTrms,
               fr = object@frame, mc = getCall(object))
  if ("lme4conv" %in% names(formals(mkMerMod))) args$lme4conv <- cc
  result <- do.call(mkMerMod, args, TRUE, sys.frame(0))
  repackageMerMod(result, opt, environment(ff)) 
}

setClass("bmerTDist",
         representation(df = "numeric",
                        beta.0 = "numeric",
                        d = "numeric",
                        R.scale.inv = "matrix"),
         contains = "bmerDist")

toString.bmerTDist <- function(x, digits = getOption("digits"), ...) {
  scaleString <- ""
  scale <- if (x@d != nrow(x@R.scale.inv)) diag(1 / diag(x@R.scale.inv)^2) else crossprod(solve(x@R.scale.inv))
    
  meanString <- ""
  beta.0 <- x@beta.0
  if (length(beta.0) > 4L) {
    meanString <- paste0("mean = c(", toString(round(beta.0[seq_len(4L)], digits)), ", ...)")
  } else if (length(beta.0) == 1L) {
    meanString <- paste0("mean = ", toString(round(beta.0[1L], digits)))
  } else {
    meanString <- paste0("mean = c(", toString(round(beta.0, digits)), ")")
  }
  if (all(scale[lower.tri(scale) | upper.tri(scale)] == 0)) {
    scale <- diag(scale)
    if (length(scale) > 4L) {
      scaleString <- paste0("diag(scale) = c(", toString(round(scale[seq_len(4L)], digits)), ", ...")
    } else if (length(scale) == 1L) {
      scaleString <- paste0("scale = ", toString(round(scale[1L], digits)))
    } else {
      scaleString <- paste0("diag(scale) = c(", toString(round(scale, digits)), ")")
    }
  } else {
    if (nrow(scale) > 2L) {
      scaleString <- paste0("scale = c(", toString(round(scale[seq_len(4L)], digits)), ", ...)")
    } else if (nrow(scale) == 2L) {
      scaleString <- paste0("scale = c(", toString(round(scale[seq_len(4L)], digits)), ")")
    } else {
      scaleString <- paste0("scale = ", toString(round(scale[1L], digits)))
    }
  }
    
  paste0("t(df = ", x@df, ", ", meanString, ", ", scaleString, ", ",
        "common.scale = ", x@commonScale, ")")
}
setMethod("getDFAdjustment", "bmerTDist",
  function(object) {
    if (object@commonScale == TRUE) object@d else 0
  }
)
setMethod("getConstantTerm", "bmerTDist",
  function(object) {
    R.scale.inv <- object@R.scale.inv
    d <- object@d
    df <- object@df
    
    ldet <- sum(log(if (d != nrow(R.scale.inv)) { p <- diag(R.scale.inv); p[p > 0] } else diag(R.scale.inv)))
    
    -2.0 * lgamma(0.5 * (df + d)) + 2.0 * lgamma(0.5 * df) +
      d * (log(df) + log(pi)) - 2.0 * ldet
  }
)
setMethod("getExponentialTerm", "bmerTDist",
  function(object, beta, sigma = NULL) {
    beta.0 <- object@beta.0
    R.scale.inv <- object@R.scale.inv
    d <- object@d
    df <- object@df

    dist <- tcrossprod(crossprod(beta - beta.0, R.scale.inv))[1L]
    if (object@commonScale == TRUE && !is.null(sigma)) dist <- dist / sigma^2
    if (any(is.na(dist)) || any(is.infinite(dist))) stop("non-finite or NA result in t-prior")
    
    exponential <- (df + d) * log(1 + dist / df)
    c(0, exponential)
  }
)

setClass("bmerCustomDist",
         representation(fnName = "name",
                        fn     = "function",
                        chol   = "logical",
                        scale  = "character"),
         contains = "bmerDist",
         validity = function(object) object@scale == "log" || object@scale == "dev" || object@scale == "none")

toString.bmerCustomDist <- function(x, digits = getOption("digits"), ...) {
  paste0("custom(fn = ", x@fnName, ", ",
         "chol = ", x@chol, ", ",
         "scale = ", x@scale, ", ",
         "common.scale = ", x@commonScale, ")")
}

setMethod("getExponentialTerm", "bmerCustomDist",
  function(object, Lambda.t) {
    result <- object@fn(if (object@chol) Lambda.t else crossprod(Lambda.t))
    
    if (object@scale == "log") {
      result <- -2 * result
    } else if (object@scale == "none") {
      result <- -2 * log(result)
    }
    
    c(0, result)
  })

covariancePriorsToString <- function(covPriors, numGroupsPerFactor, digits)
{
  result <- character(0L)
  resultIndex <- 1L
  
  numFactors <- length(numGroupsPerFactor)
  factorNames <- names(numGroupsPerFactor)
  for (i in seq_len(numFactors)) {
    prior.i <- covPriors[[i]]

    if (is.null(prior.i)) next

    result[resultIndex] <- paste(factorNames[i], " ~ ", toString(prior.i, digits), sep = "")
    resultIndex <- resultIndex + 1L
  }

  result
}

printPriors <- function(priors, numGroupsPerFactor, digits) {
  covariancePriorOutput <- covariancePriorsToString(priors$covPriors, numGroupsPerFactor, digits)
  if (length(covariancePriorOutput) > 0L) {
    cat("Cov prior  : ", covariancePriorOutput[1L], "\n", sep="")
    if (length(covariancePriorOutput) > 1L) {
      for (i in seq.int(2L, length(covariancePriorOutput)))
        cat("           : ", covariancePriorOutput[i], "\n", sep="")
    }
  }
  if (!is.null(priors$fixefPrior))
    cat("Fixef prior: ", toString(priors$fixefPrior, digits), "\n", sep="")

  if (!is.null(priors$residPrior))
    cat("Resid prior: ", toString(priors$residPrior, digits, FALSE), "\n", sep="")
}

mkBlmerDevfun <- function(fr, X, reTrms, REML = TRUE, start = NULL,
                          verbose = 0L, control = lmerControl(), priors = NULL,
                          env = parent.frame(1L), ...) {
  devfun <- mkLmerDevfun(fr, X, reTrms, REML, start, verbose, control, ...)
  devFunEnv <- environment(devfun)
  pred <- devFunEnv$pp
  resp <- devFunEnv$resp
  
  devFunEnv$ranefStructure <- getRanefStructure(pred, resp, reTrms)
  
  if (is.null(priors)) priors <- list()
  devFunEnv$priors <-
    evaluatePriorArguments(priors$covPriors, priors$fixefPrior, priors$residPrior,
                           c(n = nrow(X), p = ncol(X), GLMM = 0L, REML = if (REML) 1L else 0L),
                           colnames(X),
                           reTrms$cnms, devFunEnv$ranefStructure$numGroupsPerFactor,
                           env)
  
  devFunEnv$blmerControl <- createBlmerControl(pred, resp, devFunEnv$priors)
  devFunEnv$parInfo <- getParInfo(pred, resp, devFunEnv$ranefStructure, devFunEnv$blmerControl)
  devFunBody <- getBlmerDevianceFunctionBody(devFunEnv)

  if (!is.null(devFunBody)) body(devfun) <- parse(text = devFunBody)

  devfun
}

mkBglmerDevfun <- function(fr, X, reTrms, family, nAGQ = 1L, verbose = 0L,
                           maxit = 100L,
                           control=glmerControl(),
                           priors = NULL, env = parent.frame(1L), ...) {
  devfun <-
    if (packageVersion("lme4") <= "1.1.7") {
     mkGlmerDevfun(fr, X, reTrms, family, nAGQ, verbose, control, ...)
    } else {
     mkGlmerDevfun(fr, X, reTrms, family, nAGQ, verbose, maxit, control, ...)
    }
  
  devFunEnv <- environment(devfun)
  pred <- devFunEnv$pp
  resp <- devFunEnv$resp

  devFunEnv$ranefStructure <- getRanefStructure(pred, resp, reTrms)
  if (is.null(priors)) priors <- list()
  devFunEnv$priors <-
    evaluatePriorArguments(priors$covPriors, priors$fixefPrior, NULL,
                           c(n = nrow(X), p = ncol(X), GLMM = 1L),
                           colnames(X),
                           reTrms$cnms, devFunEnv$ranefStructure,
                           env)

  
  devFunEnv$blmerControl <- createBlmerControl(pred, resp, devFunEnv$priors)
  devFunEnv$parInfo <- getParInfo(pred, resp, devFunEnv$ranefStructure, devFunEnv$blmerControl)

  devFunBody <- getBglmerDevianceFunctionBody(devFunEnv, nAGQ != 0L)

  if (!is.null(devFunBody)) body(devfun) <- parse(text = devFunBody)
  
  devfun
}

makeRefitDevFun <- function(env, nAGQ = 1L, verbose = 0, maxit=100L,
                            control = list(),
                            object) {
  lme4Namespace <- asNamespace("lme4")
  devfun <-
    if (packageVersion("lme4") <= "1.1.7") {
      get("mkdevfun", lme4Namespace)(env, nAGQ, verbose, control)
    } else
      get("mkdevfun", lme4Namespace)(env, nAGQ, maxit, verbose, control)
  
  pred <- env$pp
  resp <- env$resp
  
  env$maxit <- as.integer(maxit)
  env$lower <- object@lower
  env$priors <- object@priors
  env$ranefStructure <- getRanefStructure(pred, resp, list(cnms = object@cnms, Gp = object@Gp))
  env$blmerControl <- createBlmerControl(pred, resp, env$priors)
  env$parInfo <- getParInfo(pred, resp, env$ranefStructure, env$blmerControl)

  devFunBody <-
    if (is(resp, "lmerResp"))
      getBlmerDevianceFunctionBody(env)
    else
      getBglmerDevianceFunctionBody(env, nAGQ != 0L)
  
  if (!is.null(devFunBody)) body(devfun) <- parse(text = devFunBody)
  
  devfun
}

## environment already populated at this point
updateBglmerDevfun <- function(devfun, reTrms, nAGQ = 1L) {
  devfun <- updateGlmerDevfun(devfun, reTrms, nAGQ = nAGQ)
  devFunEnv <- environment(devfun)
  devFunBody <- getBglmerDevianceFunctionBody(devFunEnv, nAGQ != 0L)

  if (!is.null(devFunBody)) body(devfun) <- parse(text = devFunBody)

  devfun
}


getBlmerDevianceFunctionBody <- function(devFunEnv)
{
  priors <- devFunEnv$priors
  
  if (!anyPriorsApplied(priors)) return(NULL)

  blmerControl <- devFunEnv$blmerControl
  
  sigmaOptimizationType <- blmerControl$sigmaOptimizationType
  fixefOptimizationType <- blmerControl$fixefOptimizationType

  fixefPrior <- priors$fixefPrior

  devFunBody <- NULL
  stringConnection <- textConnection("devFunBody", "w", local=TRUE)
  sink(stringConnection)

  cat("{\n")
  cat("  expandParsInCurrentFrame(theta, parInfo)\n",
      "  pp$setTheta(as.double(theta))\n\n", sep = "")
  devFunEnv$expandParsInCurrentFrame <- expandParsInCurrentFrame
  
  if (sigmaOptimizationType == SIGMA_OPTIM_POINT)
    cat("  sigma <- priors$residPrior@value\n")

  if (is(fixefPrior, "bmerNormalDist")) {
    if (fixefPrior@commonScale == FALSE) {
      cat("  pp$updateDecomp(sigma * priors$fixefPrior@R.cov.inv)\n")
    } else {
      cat("  pp$updateDecomp(priors$fixefPrior@R.cov.inv)\n")
    }
  } else {
    cat("  pp$updateDecomp()\n")
  }

  cat("\n")

  cat("  resp$updateMu(pp$linPred(0.0))\n",
      "  pp$updateRes(resp$wtres)\n",
      "  pp$solve()\n",
      "  resp$updateMu(pp$linPred(1.0))\n\n", sep = "")

  if (fixefOptimizationType != FIXEF_OPTIM_NUMERIC) {
    cat("  beta <- pp$beta(1.0)\n")
  }
  cat("  Lambda.ts <- getCovBlocks(pp$Lambdat, ranefStructure)\n")
  if (sigmaOptimizationType == SIGMA_OPTIM_NUMERIC ||
      sigmaOptimizationType == SIGMA_OPTIM_POINT) {
    cat("  exponentialTerms <- calculatePriorExponentialTerms(priors, beta, Lambda.ts, sigma)\n")
  } else {
    cat("  exponentialTerms <- calculatePriorExponentialTerms(priors, beta, Lambda.ts)\n")
  }
  cat("  polynomialTerm <- calculatePriorPolynomialTerm(priors$covPriors, Lambda.ts)\n\n")
  devFunEnv$calculatePriorExponentialTerms <- calculatePriorExponentialTerms
  devFunEnv$calculatePriorPolynomialTerm <- calculatePriorPolynomialTerm
  devFunEnv$getCovBlocks <- getCovBlocks

  if (fixefOptimizationType == FIXEF_OPTIM_NUMERIC) {
    cat("  exponentialTerms <- calculateFixefExponentialTerm(beta, pp$beta(1.0), pp$RX(), exponentialTerms)\n")
    devFunEnv$calculateFixefExponentialTerm <- calculateFixefExponentialTerm
  }
  
  if (sigmaOptimizationType != SIGMA_OPTIM_NUMERIC &&
      sigmaOptimizationType != SIGMA_OPTIM_POINT) {
    cat("  sigma <- profileSigma(pp, resp, exponentialTerms, blmerControl)\n\n", sep = "")
    devFunEnv$profileSigma <- getSigmaProfiler(priors, blmerControl)
  }

  cat("  lmmObjective(pp, resp, sigma, exponentialTerms, polynomialTerm, blmerControl)\n")
  devFunEnv$lmmObjective <- lmmObjective
  
  cat("}\n")
  
  sink()
  close(stringConnection)
  
  devFunBody
}

anyPriorsApplied <- function(priors) {
  !is.null(priors$fixefPrior) || any(sapply(priors$covPriors, function(cov.prior.i) !is.null(cov.prior.i))) ||
  !is.null(priors$residPrior)
}

getSigmaProfiler <- function(priors, blmerControl) {
  sigmaOptimizationType <- blmerControl$sigmaOptimizationType
  if (sigmaOptimizationType == SIGMA_OPTIM_SQ_LINEAR) {
    return (function(pp, resp, exponentialTerms, blmerControl) {
      pwrss <- resp$wrss() + pp$sqrL(1.0)
      if (!is.null(exponentialTerms[["-2"]])) pwrss <- pwrss + exponentialTerms[["-2"]]

      df <- nrow(pp$X) - resp$REML + blmerControl$df

      sqrt(pwrss / df)
    })
  } else if (sigmaOptimizationType == SIGMA_OPTIM_SQ_QUADRATIC) {
    return (function(pp, resp, exponentialTerms, blmerControl) {
      pwrss <- resp$wrss() + pp$sqrL(1.0)
      if (!is.null(exponentialTerms[["-2"]])) pwrss <- pwrss + exponentialTerms[["-2"]]
      a <- exponentialTerms[["2"]]
      
      df <- nrow(pp$X) - resp$REML + blmerControl$df

      disc <- sqrt(df^2 + 4 * pwrss * a)
      
      sqrt((disc - df) / (2 * a))
    })
  } else if (sigmaOptimizationType == SIGMA_OPTIM_QUADRATIC) {
    return (function(pp, resp, exponentialTerms, blmerControl) {
      pwrss <- resp$wrss() + pp$sqrL(1.0)
      if (!is.null(exponentialTerms[["-2"]])) pwrss <- pwrss + exponentialTerms[["-2"]]
      a <- exponentialTerms[["-1"]]
      
      df <- nrow(pp$X) - resp$REML + blmerControl$df

      disc <- sqrt(a^2 + 16 * df * pwrss)
      
      0.25 * (disc + a) / df
    })
  } else stop("illegal sigma optimization type")
}

calculatePriorExponentialTerms <- function(priors, beta, Lambda.ts, sigma = NULL)
{
  result <- list()
  fixefPrior <- priors$fixefPrior
  covPriors  <- priors$covPriors
  residPrior <- priors$residPrior

  if (!is.null(fixefPrior)) {
    if ((is(fixefPrior, "bmerTDist") || is(fixefPrior, "bmerHorseshoeDist")) && fixefPrior@commonScale == TRUE) {
      term <- getExponentialTerm(fixefPrior, beta, sigma)
    } else {
      term <- getExponentialTerm(fixefPrior, beta)
    }
    result[[toString(term[1L])]] <- term[2L]
  }

  for (i in seq_along(covPriors)) {
    if (is.null(covPriors[[i]])) next
    covPrior.i <- covPriors[[i]]

    if (is(covPrior.i, "bmerCustomDist") && covPrior.i@commonScale == FALSE) {
      term <- getExponentialTerm(covPrior.i, Lambda.ts[[i]] * sigma)
    } else {
      term <- getExponentialTerm(covPrior.i, Lambda.ts[[i]])
    }
    power <- toString(term[1L])
    exponential <- term[2L]
    if (is.null(result[[power]])) result[[power]] <- exponential
    else result[[power]] <- result[[power]] + exponential
  }

  if (is.null(residPrior)) return(result)
  
  term <- getExponentialTerm(residPrior)
  power <- toString(term[1L])
  exponential <- term[2L]
  if (is.null(result[[power]])) result[[power]] <- exponential
  else result[[power]] <- result[[power]] + exponential

  result
}

calculatePriorPolynomialTerm <- function(covPriors, Lambda.ts)
{
  sum(sapply(seq_along(covPriors), function(i)
      if (!is.null(covPriors[[i]])) getPolynomialTerm(covPriors[[i]], Lambda.ts[[i]]) else 0))
}

calculateFixefExponentialTerm <- function(beta, beta.tilde, RX, exponentialTerms = NULL)
{
  exponential <- crossprod(RX %*% (beta - beta.tilde))[1L]
  if (is.null(exponentialTerms)) return(exponential)
  
  if (is.null(exponentialTerms[["-2"]])) {
    exponentialTerms[["-2"]] <- exponential
  } else {
    exponentialTerms[["-2"]] <- exponentialTerms[["-2"]] + exponential
  }
  exponentialTerms
}

testGetBglmerDevianceFunctionBody <- function(devFun)
{
  devFunEnv <- environment(devFun)
  priors <- devFunEnv$priors
  
  if (!anyPriorsApplied(priors)) return(NULL)

  fixefPrior <- priors$fixefPrior
  
  devFunBody <- NULL
  stringConnection <- textConnection("devFunBody", "w", local = TRUE)
  sink(stringConnection)

  cat("{\n",
      "  Lambda.ts        <- getCovBlocks(pp$Lambdat, ranefStructure)\n",
      "  exponentialTerms <- calculatePriorExponentialTerms(priors, spars, Lambda.ts)\n",
      "  polynomialTerm   <- calculatePriorPolynomialTerm(priors$covPriors, Lambda.ts)\n\n",
      "  ",
      sep = "")
  
  oldDevFunBody <- deparse(body(devFun))
  cat(oldDevFunBody[-length(oldDevFunBody)], sep = "\n") ## cut trailing "}"

  cat("  } + exponentialTerms[[1]] + polynomialTerm + blmerControl$constant\n",
      "}", sep = "")

  sink()
  close(stringConnection)
  
  devFunBody
}

getBglmerDevianceFunctionBody <- function(devFunEnv, fixefAreParams)
{
  priors <- devFunEnv$priors
  
  if (!anyPriorsApplied(priors)) return(NULL)

  fixefPrior <- priors$fixefPrior

  devFunBody <- NULL
  stringConnection <- textConnection("devFunBody", "w", local=TRUE)
  sink(stringConnection)

  cat("{\n")

  if (fixefAreParams)
    cat("  resp$setOffset(baseOffset)\n")

  cat("  resp$updateMu(lp0)\n")

  if (!fixefAreParams) {
    cat("  spars <- rep(0, ncol(pp$X))\n",
        "  pp$setTheta(as.double(theta))\n", sep = "")
    if (packageVersion("lme4") <= "1.1.7") {
      cat("  p <- pwrssUpdate(pp, resp, tolPwrss, GHrule(0L), compDev, verbose=verbose)\n")
    } else {
      cat("  p <- pwrssUpdate(pp, resp, tolPwrss, GHrule(0L), compDev, maxit=maxit, verbose=verbose)\n")
    }
  } else {
    cat("  pp$setTheta(as.double(pars[dpars]))\n",
        "  spars <- as.numeric(pars[-dpars])\n",
        "  offset <- if (length(spars) == 0) baseOffset else baseOffset + pp$X %*% spars\n",
        "  resp$setOffset(offset)\n\n", sep = "")
    if (packageVersion("lme4") <= "1.1.7") {
      cat("  p <- pwrssUpdate(pp, resp, tolPwrss, GQmat, compDev, fac, verbose=verbose)\n")
    } else {
      cat("  p <- pwrssUpdate(pp, resp, tolPwrss, GQmat, compDev, fac, maxit=maxit, verbose=verbose)\n")
    }
  }
  
  cat("  resp$updateWts()\n\n",
      
      "  Lambda.ts <- getCovBlocks(pp$Lambdat, ranefStructure)\n",
      "  exponentialTerms <- calculatePriorExponentialTerms(priors, spars, Lambda.ts)\n",
      "  polynomialTerm <- calculatePriorPolynomialTerm(priors$covPriors, Lambda.ts)\n\n",
      
      "  p + exponentialTerms[[1]] + polynomialTerm + blmerControl$constant\n",
      "}\n",
      sep = "")
  devFunEnv$getCovBlocks <- getCovBlocks
  devFunEnv$calculatePriorExponentialTerms <- calculatePriorExponentialTerms
  devFunEnv$calculatePriorPolynomialTerm <- calculatePriorPolynomialTerm
  
  sink()
  close(stringConnection)
  
  devFunBody
}

setClass("bmerPointDist",
         representation(value = "numeric"),
         contains = "bmerDist")

toString.bmerPointDist <- function(x, digits = getOption("digits"), ...)
  paste("point(value = ", round(x@value, digits), ")", sep = "")

setClass("bmerGammaDist",
         representation(shape = "numeric",
                        rate  = "numeric",
                        posteriorScale = "character"),
         contains = "bmerDist",
         validity = function(object) object@posteriorScale == "var" || object@posteriorScale == "sd")
setClass("bmerInvGammaDist",
         representation(shape = "numeric",
                        scale = "numeric",
                        posteriorScale = "character"),
         contains = "bmerDist",
         validity = function(object) object@posteriorScale == "var" || object@posteriorScale == "sd")

toString.bmerGammaDist <- function(x, digits = getOption("digits"), includeCommonScale = TRUE, ...) {
  paste("gamma(shape = ", round(x@shape, digits),
        ", rate = ", round(x@rate, digits),
        ", posterior.scale = ", x@posteriorScale,
        if (includeCommonScale) paste(", common.scale = ", x@commonScale, sep = "") else "",
        ")", sep="")
}

toString.bmerInvGammaDist <- function(x, digits = getOption("digits"), includeCommonScale = TRUE, ...) {
  paste("invgamma(shape = ", round(x@shape, digits),
        ", scale = ", round(x@scale, digits),
        ", posterior.scale = ", x@posteriorScale,
        if (includeCommonScale) paste(", common.scale = ", x@commonScale, sep = "") else "",
        ")", sep="")
}

setMethod("getDFAdjustment", "bmerGammaDist",
  function(object) {
    if (object@commonScale) 0 else {
      if (object@posteriorScale == 'sd')
             -(object@shape - 1.0)
      else
        -2.0 * (object@shape - 1.0)
    }
  }
)
setMethod("getDFAdjustment", "bmerInvGammaDist",
  function(object) {
    if (object@commonScale) 0 else {
      if (object@posteriorScale == 'sd')
              (object@shape + 1.0)
      else
        2.0 * (object@shape + 1.0)
    }
  }
)

setMethod("getConstantTerm", "bmerGammaDist",
  function(object) {
    shape <- object@shape; rate <- object@rate
    if (shape == 0.0 || rate == 0.0) return(0.0)
    if (shape <  0.0 || rate <  0.0) return(NaN)

    -2.0 * (shape * log(rate) - lgamma(shape))
  }
)
setMethod("getConstantTerm" ,"bmerInvGammaDist",
  function(object) {
    shape <- object@shape; scale <- object@scale
    
    if (shape == 0.0 || scale == 0.0) return(0.0)
    if (shape <  0.0 || scale <  0.0) return(NaN)
  
    -2.0 * (shape * log(scale) - lgamma(shape))
  }
)

setMethod("getExponentialSigmaPower", "bmerGammaDist",
  function (object) {
    if (object@commonScale || object@rate == 0) return(0)
    
    if (object@posteriorScale == "sd") 1 else 2
  })

setMethod("getExponentialSigmaPower", "bmerInvGammaDist",
  function (object) {
    if (object@commonScale || object@scale == 0) return(0)
    
    if (object@posteriorScale == "sd") -1 else -2
  })

setMethod("getExponentialTerm", "bmerGammaDist",
  function(object, lambda) {
    if (object@rate == 0) return (c(0, 0.0))

    if (missing(lambda)) lambda <- 1.0
    
    if (object@posteriorScale == "var") {
      exponential <- 2.0 * lambda^2 * object@rate
      power <- 2
    } else {
      exponential <- 2.0 * lambda * object@rate
      power <- 1
    }

    if (object@commonScale == TRUE) c(0, exponential) else c(power, exponential)
  })

setMethod("getExponentialTerm", "bmerInvGammaDist",
  function(object, lambda) {
    if (object@scale == 0) return (c(0, 0.0))

    if (missing(lambda)) lambda <- 1.0
    
    if (object@posteriorScale == "var") {
      exponential <- 2.0 * object@scale / lambda^2
      power <- -2
    } else {
      exponential <- 2.0 * object@scale / lambda
      power <- -1
    }

    if (object@commonScale == TRUE) c(0, exponential) else c(power, exponential)
  })

setMethod("getPolynomialTerm", "bmerGammaDist",
  function(object, lambda) {
    if (object@posteriorScale == "var")
      -4 * (object@shape - 1.0) * log(lambda)
    else
      -2 * (object@shape - 1.0) * log(lambda)
  }
)

setMethod("getPolynomialTerm", "bmerInvGammaDist",
  function(object, lambda) {
    if (object@posteriorScale == "var")
      4.0 * (object@shape + 1.0) * log(lambda)
    else
      2.0 * (object@shape + 1.0) * log(lambda)
  }
)

## derived from lme4/R/modular.R

optimizeLmer <- function(devfun,
                         optimizer    = formals(lmerControl)$optimizer,
                         restart_edge = formals(lmerControl)$restart_edge,
                         boundary.tol = formals(lmerControl)$boundary.tol,
                         start   = NULL,
                         verbose = 0L,
                         control = list(),
                         ...) {
  verbose <- as.integer(verbose)
  rho <- environment(devfun)

  lme4Env <- asNamespace("lme4")
  
  parInfo <- rho$parInfo
  startingValues <- getStartingValues(start, rho, parInfo)
  lowerBounds <- getLowerBounds(parInfo)
  rho$lower <- lowerBounds ## b/c lower bounds are pulled from devfunenv to check convergence
  thetaLowerBounds <- lowerBounds[seq_along(rho$pp$theta)]
  
  optwrap <- get("optwrap", lme4Env)
  lme4IsOld <- is.null(formals(optwrap)[["calc.derivs"]])
  opt <-
    if (!lme4IsOld)
      optwrap(optimizer, devfun, startingValues, lower = lowerBounds, control = control, adj = FALSE, verbose = verbose, ...)
    else
      optwrap(optimizer, devfun, startingValues, lower = lowerBounds, control = control, adj = FALSE, verbose = verbose)
  
  if (restart_edge) {
    ## FIXME: should we be looking at rho$pp$theta or opt$par
    ##  at this point???  in koller example (for getData(13)) we have
    ##   rho$pp$theta=0, opt$par=0.08
    if (length(bvals <- which(rho$pp$theta == thetaLowerBounds)) > 0L) {
      par <- opt$par
      ## *don't* use numDeriv -- cruder but fewer dependencies, no worries
      ##  about keeping to the interior of the allowed space
      theta0 <- new("numeric", rho$pp$theta) ## 'deep' copy ...
      d0 <- devfun(par)
      btol <- 1e-5  ## FIXME: make user-settable?
      bgrad <- sapply(bvals,
                      function(i) {
                        bndval <- rho$lower[i]
                        par[seq_along(theta0)] <- theta0
                        par[i] <- bndval + btol
                        (devfun(par) - d0) / btol
                      })
      ## what do I need to do to reset rho$pp$theta to original value???
      par[seq_along(theta0)] <- theta0
      devfun(par) ## reset rho$pp$theta after tests
      ## FIXME: allow user to specify ALWAYS restart if on boundary?
      if (any(bgrad < 0)) {
        if (verbose) message("some theta parameters on the boundary, restarting")
        opt <- if (!lme4IsOld)
          optwrap(optimizer, devfun, opt$par, lower = lowerBounds, control = control, adj = FALSE, verbose = verbose, ...)
        else
          optwrap(optimizer, devfun, opt$par, lower = lowerBounds, control = control, adj = FALSE, verbose = verbose)
      }
    }
  }
  if (!is.null(boundary.tol) && boundary.tol > 0) {
    if (exists("check.boundary", lme4Env))
      opt <- get("check.boundary", lme4Env)(rho, opt, devfun, boundary.tol)
  }
  
  opt
}

evaluateFixefPrior <- function(fixefPrior, defnEnv, evalEnv) {
  if (is.character(fixefPrior)) fixefPrior <- parse(text = fixefPrior)[[1L]]
  
  if (is.symbol(fixefPrior) && exists(toString(fixefPrior), envir = evalEnv) &&
      !(as.character(fixefPrior) %in% fixefDistributions)) {
    fixefPrior <- get(toString(fixefPrior), envir = evalEnv)
    if (is.character(fixefPrior)) fixefPrior <- parse(text = fixefPrior)[[1L]]
  }
  
  if (!is.null(fixefPrior)) {
    if (is.symbol(fixefPrior)) fixefPrior <- call(as.character(fixefPrior))
    fixefDistributionName <- as.character(fixefPrior[[1L]])
    if (!(fixefDistributionName %in% fixefDistributions)) stop("unrecognized fixef distribution: '", fixefDistributionName, "'")

    return(eval(fixefPrior, envir = evalEnv))
  }
  
  NULL
}

evaluateCovPriors <- function(covPriors, factorColumnNames, numGroupsPerFactor, defnEnv, evalEnv, callingEnv) {
  numFactors <- length(factorColumnNames)
  factorNames <- names(factorColumnNames)
  result <- vector("list", numFactors)
  defaultCovPrior <- NULL
  
  if (is.null(covPriors)) return(result)
  
  # check to see if it refers to a variable in the calling environment
  if (is.symbol(covPriors) && as.character(covPriors) %not_in% covDistributions) {
    tryResult <- tryCatch(variableLookup <- get(as.character(covPriors), envir = callingEnv), error = I)
    
    if (!is(tryResult, "error")) covPriors <- variableLookup
  }
  
  if (is.character(covPriors)) {
    covPriors <- gsub("inverse.wishart", "invwishart", covPriors)
    covPriors <- gsub("inverse.gamma", "invgamma", covPriors)
    covPriors <- parse(text = covPriors)[[1L]]
  }
  
  if (is.call(covPriors) && covPriors[[1L]] == "list") covPriors[[1L]] <- NULL
  
  if (!is.list(covPriors)) covPriors <- list(covPriors)

  for (i in seq_along(covPriors)) {
    covPrior.i <- covPriors[[i]]
    ## can't just let 'em re-define "wishart", or use the built-in gamma
    if (is.symbol(covPrior.i) && exists(as.character(covPrior.i), envir = evalEnv) &&
        !(as.character(covPrior.i) %in% covDistributions)) {
      covPrior.i <- get(toString(covPrior.i), envir = evalEnv)
      if (is.character(covPrior.i)) covPrior.i <- parse(text = covPrior.i)[[1]]
      covPriors[[i]] <- covPrior.i
    }
  }
  for (i in seq_along(covPriors)) {
    covPrior.i <- covPriors[[i]]
    if (is.character(covPrior.i)) {
      covPrior.i <- gsub("inverse.wishart", "invwishart", covPrior.i)
      covPrior.i <- gsub("inverse.gamma", "invgamma", covPrior.i)
      covPrior.i <- parse(text = covPrior.i)[[1]]
    }

    ## turn 'wishart' into 'wishart()'
    if (is.symbol(covPrior.i)) covPrior.i <- call(as.character(covPrior.i))
    
    if (is.formula(covPrior.i)) {
      factorName <- as.character(covPrior.i[[2L]])

      if (!(factorName %in% factorNames))
        stop("grouping factor '", factorName, "' for covariance prior not in model formula")
      
      ## turn 'group ~ wishart' into 'group ~ wishart()'
      if (is.symbol(covPrior.i[[3L]])) covPrior.i[[3L]] <- call(as.character(covPrior.i[[3L]]))

      ## for each grouping factor with the given name, store function call for later
      matchingFactors <- which(factorName == factorNames)
      for (j in seq_along(matchingFactors)) result[[matchingFactors[j]]] <- covPrior.i[[3L]]
      
    } else {
      ## default
      if (!is.null(defaultCovPrior)) warning("more than one default covariance prior specified, only using the last one")
      defaultCovPrior <- covPrior.i
    }
  }
  
  for (i in seq_len(numFactors)) {
    if (is.null(result[[i]]) && is.null(defaultCovPrior)) next

    result.i <- result[[i]]
    if (is.null(result[[i]]) && !is.null(defaultCovPrior)) result.i <- defaultCovPrior

    covDistributionName <- as.character(result.i[[1L]])
    if (!(covDistributionName %in% covDistributions))
      stop("unrecognized ranef covariance distribution: '", covDistributionName, "'")

    defnEnv$q.k <- defnEnv$level.dim <- length(factorColumnNames[[i]])
    defnEnv$j.k <- defnEnv$n.grps <- numGroupsPerFactor[i]
    
    result.i <- eval(result.i, envir = evalEnv)
    
    if (!is.null(result.i)) result[[i]] <- result.i
  }
  
  result
}

evaluateResidualPrior <- function(residPrior, defnEnv, evalEnv) {
  if (is.character(residPrior)) {
    residPrior <- gsub("inverse.gamma", "invgamma", residPrior)
    residPrior <- parse(text = residPrior)[[1L]]
  }

  if (is.symbol(residPrior) && exists(toString(residPrior), envir = evalEnv)) {
    fixefPrior <- get(toString(residPrior), envir = evalEnv)
    if (is.character(residPrior)) residPrior <- parse(text = residPrior)[[1]]
  }
  
  if (!is.null(residPrior)) {
    if (is.symbol(residPrior)) residPrior <- call(as.character(residPrior))
    residDistributionName <- as.character(residPrior[[1L]])
    if (!(residDistributionName %in% residDistributions)) stop("unrecognized residual variance distribution: '", residDistributionName, "'")

    return(eval(residPrior, envir = evalEnv))
  }
  
  NULL
}
  
evaluatePriorArguments <- function(covPriors, fixefPrior, residPrior,
                                   dims, fixefNames, factorColumnNames, numGroupsPerFactor, callingEnv) {
  result <- list()
  evalEnv <- new.env(parent = callingEnv)
  defnEnv <- new.env()
  
  defnEnv$p <- defnEnv$n.fixef <- dims[["p"]]
  defnEnv$n <- defnEnv$n.obs   <- dims[["n"]]
  defnEnv$.fixefNames <- fixefNames
  isLMM <- dims[["GLMM"]] == 0L
  
  ## add the names of dist functs to the evaluating env
  for (distributionName in names(lmmDistributions)) {
    distributionFunction <- lmmDistributions[[distributionName]]

    environment(distributionFunction) <- defnEnv
    if (!isLMM) {
      ## need both copies to have their envs tweaked, but only one called
      distributionFunction <- glmmDistributions[[distributionName]]
      if (!is.null(distributionFunction)) environment(distributionFunction) <- defnEnv
    }
    if (!is.null(distributionFunction)) assign(distributionName, distributionFunction, envir = evalEnv)
  }
  
  result$fixefPrior <- evaluateFixefPrior(fixefPrior, defnEnv, evalEnv)
  if ((is(result$fixefPrior, "bmerTDist") || is(result$fixefPrior, "bmerHorseshoeDist")) && isLMM && dims[["REML"]] > 0L)
    stop("t/horseshoe distribution for fixed effects only supported when REML = FALSE")
  result$covPriors  <- evaluateCovPriors(covPriors, factorColumnNames, numGroupsPerFactor, defnEnv, evalEnv, callingEnv)

  if (isLMM) {
    environment(residualVarianceGammaPrior) <- defnEnv
    environment(residualVarianceInvGammaPrior) <- defnEnv
    assign("gamma", residualVarianceGammaPrior, envir = evalEnv)
    assign("invgamma", residualVarianceInvGammaPrior, envir = evalEnv)
    
    result$residPrior <- evaluateResidualPrior(residPrior, defnEnv, evalEnv)
  }
  
  result
}

setClass("bmerHorseshoeDist",
         representation(beta.0 = "numeric",
                        tau.sq = "numeric"),
         contains = "bmerDist")

toString.bmerHorseshoeDist <- function(x, digits = getOption("digits"), ...) {  
  meanString <- ""
  beta.0 <- x@beta.0
  if (length(beta.0) > 4L) {
    meanString <- paste0("mean = c(", toString(round(beta.0[seq_len(4L)], digits)), ", ...)")
  } else if (length(beta.0) == 1L) {
    meanString <- paste0("mean = ", toString(round(beta.0[1L], digits)))
  } else {
    meanString <- paste0("mean = c(", toString(round(beta.0, digits)), ")")
  }
     
  paste0("horseshoe(", meanString, ", ",
         "global.shrinkage = ", round(sqrt(x@tau.sq), digits), ", ",
         "common.scale = ", x@commonScale, ")")
}
setMethod("getDFAdjustment", "bmerHorseshoeDist",
  function(object) {
    if (object@commonScale == TRUE) length(object@beta.0) else 0
  }
)
setMethod("getConstantTerm", "bmerHorseshoeDist",
  function(object) {
    d <- length(object@beta.0)
    
    d * (3 * log(pi) + log(2) + log(object@tau.sq))
  }
)
setMethod("getExponentialTerm", "bmerHorseshoeDist",
  function(object, beta, sigma = NULL) {
    beta.0 <- object@beta.0
    tau.sq <- object@tau.sq
    
    dist <- 0.5 * (beta - beta.0)^2 / tau.sq
    if (object@commonScale == TRUE && !is.null(sigma)) dist <- dist / sigma^2
    
    temp <- suppressWarnings(sapply(dist, expint::expint_E1, scale = TRUE))
    temp[is.nan(temp)] <- .Machine$double.xmax * .Machine$double.eps
    
    result <- -2 * sum(log(temp))
    
    c(0, result)
  }
)

setClass("bmerWishartDist",
         representation(df          = "numeric",
                        R.scale.inv = "matrix",
                        log.det.scale = "numeric",
                        posteriorScale = "character"),
         contains = "bmerDist",
         validity = function(object) object@posteriorScale == "cov" || object@posteriorScale == "sqrt")

setClass("bmerInvWishartDist",
         representation(df      = "numeric",
                        R.scale = "matrix",
                        log.det.scale = "numeric",
                        posteriorScale = "character"),
         contains = "bmerDist",
         validity = function(object) object@posteriorScale == "cov" || object@posteriorScale == "sqrt")

toString.bmerWishartDist <- function(x, digits = getOption("digits"), ...) {
  if (any(diag(x@R.scale.inv) == 0)) {
    scale <- Inf
  } else if (any(is.infinite(x@R.scale.inv))) {
    scale <- 0
  } else {
    scale <- solve(tcrossprod(x@R.scale.inv))
  }
  
  if (length(scale) == 1) {
    scaleString <- round(scale, digits)
  } else if (nrow(scale) > 2) {
    scaleString <- paste("c(", toString(round(scale[1:3], digits)), ", ...)", sep = "")
  } else if (nrow(scale) == 2) {
    scaleString <- paste("c(", toString(round(scale[1:4], digits)), ")", sep = "")
  }
  
  paste("wishart(",
        "df = ", round(x@df, digits),
        ", scale = ", scaleString,
        ", posterior.scale = ", x@posteriorScale,
        ", common.scale = ", x@commonScale,
        ")", sep="")
}

toString.bmerInvWishartDist <- function(x, digits = getOption("digits"), ...) {
  if (any(diag(x@R.scale) == 0)) {
    scale <- 0
  } else if (any(is.infinite(x@R.scale))) {
    scale <- Inf
  } else {
    scale <- crossprod(x@R.scale)
  }
  
  if (length(scale) == 1) {
    scaleString <- round(scale, digits)
  } else if (nrow(scale) > 2) {
    scaleString <- paste("c(", toString(round(scale[1:3], digits)), ", ...)", sep = "")
  } else if (nrow(scale) == 2) {
    scaleString <- paste("c(", toString(round(scale[1:4], digits)), ")", sep = "")
  }
  
  paste("invwishart(",
        "df = ", round(x@df, digits),
        ", scale = ", scaleString,
        ", posterior.scale = ", x@posteriorScale,
        ", common.scale = ", x@commonScale,
        ")", sep="")
}

setMethod("getDFAdjustment", "bmerWishartDist",
  function(object) {
    factorDim <- nrow(object@R.scale.inv)
    if (object@commonScale || !is.finite(object@log.det.scale)) 0 else -factorDim * (object@df - factorDim - 1.0)
  }
)

setMethod("getDFAdjustment", "bmerInvWishartDist",
  function(object) {
    factorDim <- nrow(object@R.scale)
    if (object@commonScale || !is.finite(object@log.det.scale)) 0 else factorDim * (object@df + factorDim + 1.0)
  }
)

setMethod("getConstantTerm", "bmerWishartDist",
  function(object) {
    df <- object@df; R.scale.inv <- object@R.scale.inv
    log.det.scale <- object@log.det.scale
    
    if (is.infinite(log.det.scale)) return (0.0)

    factorDim <- nrow(R.scale.inv)
    
    result <- df * (factorDim * log(2) + log.det.scale) +
      0.5 * factorDim * (factorDim - 1.0) * log(pi)
    for (i in 1:factorDim)
      result <- result + 2.0 * lgamma(0.5 * (df + 1.0 - i))

    result
  }
)

setMethod("getConstantTerm", "bmerInvWishartDist",
  function(object) {
    df <- object@df; R.scale <- object@R.scale
    log.det.scale <- object@log.det.scale
    
    if (is.infinite(log.det.scale)) return (0.0)

    factorDim <- nrow(R.scale)

    result <- df * (factorDim * log(2) - log.det.scale) +
      0.5 * factorDim * (factorDim - 1.0) * log(pi)
    for (i in 1:factorDim)
      result <-  result + 2.0 * lgamma(0.5 * (df + 1.0 - i))

    result
  }
)

setMethod("getExponentialSigmaPower", "bmerWishartDist",
  function (object) {
    if (object@commonScale) return(0)
    
    if (object@posteriorScale == "sqrt") 1 else 2
  })

setMethod("getExponentialSigmaPower", "bmerInvWishartDist",
  function (object) {
    if (object@commonScale) return(0)
    
    if (object@posteriorScale == "sqrt") -1 else -2
  })


setMethod("getExponentialTerm", "bmerWishartDist",
  function(object, Lambda.t) {
    if (is.infinite(object@log.det.scale)) return(c(0, 0.0))

    if (object@posteriorScale == "cov") {
      temp <- Lambda.t %*% object@R.scale.inv
      exponential <- sum(temp^2)
      
      power <- 2
    } else {
      Sigma <- crossprod(Lambda.t)
      decomp <- eigen(Sigma)
      Sigma.sqrt <- decomp$vectors %*% tcrossprod(diag(sqrt(decomp$values)), decomp$vectors)
      exponential <- sum(Sigma.sqrt * crossprod(object@R.scale.inv))

      power <- 1
    }
    
    if (object@commonScale) c(0, exponential) else c(power, exponential)
  }
)

setMethod("getExponentialTerm", "bmerInvWishartDist",
  function(object, Lambda.t) {
    if (is.infinite(object@log.det.scale)) return(c(0, 0.0))
    
    if (object@posteriorScale == "cov") {
      power <- -2
      
      if (any(diag(Lambda.t) == 0))
        return (if (object@commonScale) c(0, Inf) else c(power, Inf))
        
      temp <- object@R.scale %*% solve(Lambda.t)
      exponential <- sum(temp^2)

    } else {
      power <- -1
      
      if (any(diag(Lambda.t) == 0))
        return (if (object@commonScale) c(0, Inf) else c(power, Inf))
      
      Sigma <- crossprod(Lambda.t)
      decomp <- eigen(Sigma)
      Sigma.inv.sqrt <- decomp$vectors %*% tcrossprod(diag(1 / sqrt(decomp$values)), decomp$vectors)
      exponential <- sum(Sigma.inv.sqrt * tcrossprod(object@R.scale))
    }

    if (object@commonScale) c(0, exponential) else c(power, exponential)
  }
)

setMethod("getPolynomialTerm", "bmerWishartDist",
  function(object, Lambda.t) {
    factorDim <- nrow(object@R.scale.inv)
    lambda <- diag(Lambda.t)
    if (any(lambda <= 0.0))
      Inf
    else
      -2.0 * (object@df - factorDim - 1.0) * sum(log(lambda))
  }
)

setMethod("getPolynomialTerm", "bmerInvWishartDist",
  function(object, Lambda.t) {
    factorDim <- nrow(object@R.scale)
    lambda <- diag(Lambda.t)
    if (any(lambda <= 0.0))
      Inf
    else
      2.0 * (object@df + factorDim + 1.0) * sum(log(lambda))
  }
)

## This is modeled a bit after	print.summary.lm :
## Prints *both*  'mer' and 'merenv' - as it uses summary(x) mainly
printBmerenv <- function(x, digits = max(3, getOption("digits") - 3),
			correlation = NULL, symbolic.cor = FALSE,
			signif.stars = getOption("show.signif.stars"),
			ranef.comp = c("Variance", "Std.Dev."), ...)
{
  printPriors(x$priors, x$ngrps, digits)
  cat("Prior dev  : ", round(x$devcomp$cmp[["penalty"]], digits), "\n\n", sep = "")
  
  printMethod <- getS3method("print", "summary.merMod")
  result <- printMethod(x, digits, correlation, symbolic.cor, signif.stars, ranef.comp, ...)
  invisible(result)
}

print.bmerMod <- function(x, digits = max(3, getOption("digits") - 3),
                          correlation = NULL, symbolic.cor = FALSE,
                          signif.stars = getOption("show.signif.stars"),
                          ranef.comp = "Std.Dev.", ...)
{
  printPriors(x@priors, x@cnms, digits)
  cat("Prior dev  : ", round(x@devcomp$cmp[["penalty"]], digits), "\n\n", sep = "")
  
  printMethod <- getS3method("print", "merMod")
  result <- printMethod(x, digits, correlation, symbolic.cor, signif.stars, ranef.comp, ...)
  invisible(result)
}

setMethod("show",  "bmerMod", function(object) print.bmerMod(object))

print.summary.bmerMod <- printBmerenv

summary.bmerMod <- function(object, ...)
{
  result <- NextMethod(.Generic, object = object, ...)
  result$priors <- object@priors
  
  structure(result,
            class = c("summary.bmerMod", "summary.merMod"))
}

summary.summary.bmerMod <- function(object, varcov = TRUE, ...) {
  getS3method("summary", "summary.merMod")(object, varcov, ...)
}

vcov.summary.bmerMod <- function(object, correlation = TRUE, ...) {
  getS3method("vcov", "summary.merMod")(object, correlation, ...)
}

\docType{class}
\name{bmerMod-class}
\title{Class "bmerMod" of Fitted Mixed-Effect Models} 
\alias{blmerMod-class}
\alias{bglmerMod-class}
\alias{bmerMod}
\alias{bmerMod-class}
\alias{print.bmerMod}
\alias{print.summary.bmerMod}
\alias{show,bmerMod-method}
\alias{show.bmerMod}
\alias{summary.bmerMod}
\alias{summary.summary.bmerMod}
\alias{vcov.summary.bmerMod}

\description{The \code{bmerMod} class represents linear or generalized
  linear or nonlinear mixed-effects models with possible priors over
  model components. It inherits from the \code{\linkS4class{merMod}}
  class.
}

\section{Objects from the Class}{
  Objects are created by calls to \code{\link{blmer}} or \code{\link{bglmer}}.
}

\section{Slots}{
  A \code{bmerMod} object contains one additional slot beyond the base
  \code{merMod} class:

  \describe{
    \item{\code{priors}:}{A named list comprised of \code{covPriors},
      \code{fixefPrior}, and \code{residPrior}.}
  }
 
  In addition, the \code{devcomp} slot, element \code{cmp} includes the
  \code{penalty} item which is the computed deviance for the priors. Add
  this to the regular deviance to obtain the value of the objective function
  that is used in optimization.
}
\seealso{
  \code{\link{blmer}} and \code{\link{bglmer}},
  which produce these objects.
  \cr
  \code{\linkS4class{merMod}}, from which this class inherits.
}
\examples{
showClass("bmerMod")
methods(class = "bmerMod")
}
\keyword{classes}

\docType{class}
\name{bmerDist-class}
\title{Bayesian Linear Mixed-Effects Model Prior Representations and bmer*Dist Methods}
% Classes
\alias{bmerDist}
\alias{bmerDist-class}
% Methods
\alias{print,bmerDist-method}
\alias{show,bmerDist-method}

\description{Objects created in the initialization step of a \pkg{blme}
  model that represent the type of prior being applied.}

\section{Objects from the Class}{Objects can be created by calls of the
  form \code{new("bmerPrior", ...)}  or, more commonly, as side effects of the
  \code{\link{blmer}} and \code{\link{bglmer}} functions.

  When using the main \code{blme} functions, the prior-related arguments can be
  passed what essentially
  are function calls with the distinction that they are delayed in evaluation
  until information about the model is available. At that time, the functions
  are \emph{defined} in a special environment and then \emph{evaluated} in an
  environment that directly inherits form the one in which \code{blmer} or
  \code{bglmer} was called. This is reflected in some of the
  prototypes of various prior-creating functions which depend on parameters not
  available in the top-level environment.

  Finally, if the trailing parentheses are omitted from a \code{blmer}/\code{bglmer}
  prior argument, they are simply added as a form of \dQuote{syntactic sugar}.
}

\section{Prior Distributions}{
  This section lists the prototypes for the functions that are called to parse
  a prior during a model fit.

  \strong{Fixed Effect Priors}

  \itemize{
    \item \code{normal(sd = c(10, 2.5), cov, common.scale = TRUE)}
    
    Applies a Gaussian prior to the fixed effects. Normal priors are constrained
    to have a mean of 0 - non-zero priors are equivalent to shifting covariates.

    The covariance hyperparameter can be specified either as a vector of standard
    deviations, using the \code{sd} argument, a vector of variances using the
    \code{cov} argument, or the entire variance/covariance matrix itself. When
    specifying standard deviations, a vector of length less than the number of fixed effects will
    have its tail repeated, while the first element is assumed to apply only
    to the intercept term. So in the default of \code{c(10, 2.5)}, the intercept
    receives a standard deviation of 10 and the various slopes are all given
    a standard deviation of 2.5.

    The \code{common.scale} argument specifies whether or not the
    prior is to be interpretted as being on the same scale as the residuals.
    To specify a prior in an absolute sense, set to \code{FALSE}. Argument
    is only applicable to linear mixed models.

    \item \code{t(df = 3, mean = 0, scale = c(10^2, 2.5^2), common.scale = TRUE)}
    
    The degrees of freedom - \code{df} argument - must be positive. If \code{mean} is
    of length 1, it is repeated for every fixed effect. Length 2 repeats just the second
    element for all slopes. Otherwise, the length must be equal to that of the number of
    fixed effects.
    
    If \code{scale} is of length 1, it is repeated along the diagonal for every
    component. Length 2 repeats just the second element for all slopes. Length equal
    to the number of fixed effects sees the vector simply turned into a diagonal matrix.
    Finally, it can be a full scale matrix, so long as it is positive definite.

    \code{t} priors for linear mixed models require that the fixed effects be added to
    set of parameters that are numerically optimized, and thus can substantially
    increase running time. In addition, when \code{common.scale} is \code{TRUE}, the
    residual variance must be numerically optimized as well. \code{normal} priors
    on the common scale can be fully profiled and do not suffer from this drawback.

    At present, \code{t} priors cannot be used with the \code{REML = TRUE} argument
    as that implies an integral without a closed form solution.

    \item \code{horseshoe(mean = 0, global.shrinkage = 2.5, common.scale = TRUE)}
    
    The horseshoe shrinkage prior is implemented similarly to the \code{t} prior, in
    that it requires adding the fixed effects to the parameter set for numeric optimization.
    
    \code{global.shrinkage}, also referred to as \eqn{\tau}, must be positive and
    is on the scale of a standard deviation. Local shrinkage parameters are treated as
    independent across all fixed effects and are integrated out. See
    \cite{Carvalho et al. (2009)} in the references.
  }

  \strong{Covariance Priors}

  \itemize{
    \item \code{gamma(shape = 2.5, rate = 0, common.scale = TRUE, posterior.scale = "sd")}

    Applicable only for univariate grouping factors. A
    rate of \code{0} or a shape of \code{0} imposes an improper prior. The
    posterior scale can be \code{"sd"} or \code{"var"} and determines the scale
    on which the prior is meant to be applied.

    \item \code{invgamma(shape = 0.5, scale = 10^2, common.scale = TRUE, posterior.scale = "sd")}
    
    Applicable only for univariate grouping factors. A
    scale of \code{0} or a shape of \code{0} imposes an improper prior. Options
    are as above.

   \item \code{wishart(df = level.dim + 2.5, scale = Inf, common.scale = TRUE, posterior.scale = "cov")}

   A scale of \code{Inf} or a shape of \code{0} imposes an improper prior. The behavior
   for singular matrices with only some infinite eigenvalues is undefined. Posterior scale
   can be \code{"cov"} or \code{"sqrt"},
   the latter of which applies to the unique matrix root that is also a valid covariance
   matrix.

   \item \code{invwishart(df = level.dim - 0.5, scale = diag(10^2 / (df + level.dim + 1), level.dim),
                        common.scale = TRUE, posterior.scale = "cov")}

   A scale of \code{0} or a shape of \code{0} imposes an improper prior. The behavior
   for singular matrices with only some zero eigenvalues is undefined.

   \item \code{custom(fn, chol = FALSE, common.scale = TRUE, scale = "none")}

   Applies to the given function (\code{fn}). If \code{chol} is \code{TRUE}, \code{fn} is
   passed a \emph{right} factor of covariance matrix; \code{FALSE} results in the matrix being
   passed directly. \code{scale} can be \code{"none"}, \code{"log"}, or \code{"dev"} corresponding to
   \eqn{p(\Sigma)}, \eqn{\log p(\Sigma)}{log p(\Sigma)}, and \eqn{-2 \log p(\Sigma)}{-2 log p(\Sigma)}
   respectively.

   Since the prior is may have an arbitrary form, setting \code{common.scale} to \code{FALSE}
   for a linear mixed model means that full profiling may no longer be possible. As such,
   that parameter is numerically optimized.
  }

  \strong{Residual Variance Priors}

  \itemize{
    \item \code{point(value = 1.0, posterior.scale = "sd")}
  
    Fixes the parameter to a specific value given as either an \code{"sd"} or a \code{"var"}.

    \item \code{gamma(shape = 0, rate = 0, posterior.scale = "var")}
    
    As above with different defaults.

    \item \code{invgamma(shape = 0, scale = 0, posterior.scale = "var")}

    As above with different defaults.
  }
}

\section{Evaluating Environment}{
  The variables that the defining environment have populated are:
  \itemize{
    \item \code{p} aliased to \code{n.fixef} - the number of fixed effects
    \item \code{n} aliased to \code{n.obs} - the number of observations
    \item \code{q.k} aliased to \code{level.dim} - for covariance priors, the dimension of the grouping factor/grouping level
    \item \code{j.k} aliased to \code{n.grps} - also for covariance priors, the number of groups that comprise a specific grouping factor
  }
}

\section{Methods}{
  \describe{
    \item{toString}{Pretty-prints the distribution and its parameters.}
  }
}

\references{
Carvalho, Carlos M., Nicholas G. Polson, and James G. Scott.
  "Handling Sparsity via the Horseshoe."
  AISTATS. Vol. 5. 2009.
}

\seealso{
  \code{\link{blmer}()} and \code{\link{bglmer}()},
  which produce these objects, and \code{\link{bmerMod-class}} objects which contain them.
}
\keyword{classes}

\name{blme}
\alias{blmer}
\alias{bglmer}
\concept{GLMM}% << so it's found
\concept{NLMM}% << so it's found
\title{Fit Bayesian Linear and Generalized Linear Mixed-Effects Models}
\description{
  Maximum a posteriori estimation for linear and generalized
  linear mixed-effects models in a Bayesian setting. Built off of
  \code{\link[lme4]{lmer}}.
}
\usage{
blmer(formula, data = NULL, REML = TRUE,
      control = lmerControl(), start = NULL, verbose = 0L,
      subset, weights, na.action, offset, contrasts = NULL,
      devFunOnly = FALSE, cov.prior = wishart,
      fixef.prior = NULL, resid.prior = NULL, \dots)
bglmer(formula, data = NULL, family = gaussian,
       control = glmerControl(), start = NULL, verbose = 0L,
       nAGQ = 1L, subset, weights, na.action, offset,
       contrasts = NULL, mustart, etastart,
       devFunOnly = FALSE, cov.prior = wishart,
       fixef.prior = NULL, \dots)
}
\arguments{
  \item{cov.prior}{a BLME \link[=bmerDist-class]{prior} or list of priors with allowable
    distributions: \code{wishart}, \code{invwishart}, \code{gamma},
    \code{invgamma}, or \code{NULL}. Imposes a prior over the covariance of the random
    effects/modeled coefficients. Default is \code{wishart}. The \code{NULL} argument
    imposes flat priors over all relevant parameters.}
  \item{fixef.prior}{a BLME prior of family \code{normal}, \code{t}, \code{horseshoe}, or \code{NULL}.
    Imposes a prior over the fixed effects/modeled coefficients.
    Default is \code{NULL}.}
  \item{resid.prior}{a BLME prior of family \code{gamma}, \code{invamma}, \code{point}
    or \code{NULL}. Imposes a prior over the noise/residual variance, also known as common scale
    parameter or the conditional variance given the random effects.
    Default is \code{NULL}.}
  \item{start}{like the \code{start} arguments for \code{\link[lme4]{lmer}} and
    \code{\link[lme4]{glmer}} a numeric vector or named list. Unlike the aforementioned,
    list members of \code{fixef} and \code{sigma} are applicable to linear mixed models
    provided that numeric optimization is required for these parameters.}
  \item{formula, data, REML, family, control, verbose, nAGQ,
    mustart, etastart, devFunOnly, \dots}{model specification arguments as in \code{\link[lme4]{lmer}} and \code{\link[lme4]{glmer}};
    see there for details.}
  \item{subset, weights, na.action, offset, contrasts}{further model
    specification arguments as in \code{\link[stats]{lm}}; see there for
    details.}
}
\details{
  The bulk of the usage for \code{blmer} and \code{bglmer} closely
  follows the functions \code{\link[lme4]{lmer}} and
  \code{\link[lme4]{glmer}}. Those help pages provide a good overview of
  fitting linear and generalized linear mixed models. The primary
  distinction is that \code{blmer} and \code{bglmer} allow the user to
  do Bayesian inference or penalized maximum likelihood, with priors imposed on the different
  model components. For the specifics of any distribution listed below,
  see the \link[=bmerDist-class]{distributions} page.
  
  \strong{Covariance Prior}
  
  The \code{cov.prior} argument applies a prior over the
  covariance matrix of the random effects/modeled coefficients.
  As there is one covariance matrix for every named grouping factor -
  that is every element that appears to the right of a vertical bar
  ("|") in the model formula - it is possible to apply as many
  different priors as there are said factors.
  
  The general formats of an argument to \code{blmer} or \code{bglmer}
  for such a prior are of the form:

\itemize{
  \item \code{cov.prior = factor.name ~ covariance.distribution(option1 = value1, \dots)}
  \item \code{cov.prior = list(fc.nm ~ dist1, fc.nm ~ dist2, ..., default.distribution)}
}
  
  If the \dQuote{\code{factor.name ~}} construct is ommitted, the prior
  is interpretted as a default and applied to all factors that
  lack specific priors of their own. Options are not required,
  but permit fine-tuning of the model.

  Supported distributions are \code{gamma}, \code{invgamma}, \code{wishart},
  \code{invwishart}, \code{NULL}, and \code{custom}.

  The \code{common.scale} option, a logical, determines whether or
  not the prior applies to in the absolute-real world
  sense (value = \code{FALSE}), or if the prior is applied to the random effect
  covariance divided by the estimated residual variance (\code{TRUE}). As a practical matter,
  when false computation can be slower as the profiled common scale may
  no longer have a closed-form solution. As such, the default for all
  cases is \code{TRUE}.

  Other options are specified along with the specific distributions and
  defaults are explained in the blme \link[=bmerDist-class]{distributions} page.  

  \strong{Fixed Effects Prior}
  
  Priors on the fixed effects, or unmodeled coefficients, are specified
  in a fashion similar to that of covariance priors. The general format is

\itemize{\item \code{fixef.prior = multivariate.distribution(options1 = value1, \dots)}}
  
  At present, the implemented multivariate distributions are \code{normal}, \code{t},
  \code{horseshoe}, and \code{NULL}. \code{t} and \code{horseshoe} priors cannot be used
  when \code{REML} is \code{TRUE}, as that integral does not have a closed form solution.

  \strong{Residual Variance Prior}

  The general format for a residual variance prior is the same as for a fixed
  effect prior. The supported distributions are \code{point}, \code{gamma},
  \code{invgamma}.

}
\value{
  An object of class \code{"\linkS4class{bmerMod}"}, for which many methods
  are available. See there for details.
}
\seealso{
  \code{\link[lme4]{lmer}}, \code{\link[lme4]{glmer}},
  \code{\linkS4class{merMod}} class, and \code{\link[stats]{lm}}.
}
\examples{
data("sleepstudy", package = "lme4")

### Examples using a covariance prior ##

# Here we are ignoring convergence warnings just to illustate how the package
# is used: this is not a good idea in practice..
control <- lmerControl(check.conv.grad = "ignore")
(fm1 <- blmer(Reaction ~ Days + (0 + Days|Subject), sleepstudy,
              control = control,
              cov.prior = gamma))
(fm2 <- blmer(Reaction ~ Days + (0 + Days|Subject), sleepstudy,
              control = control,
              cov.prior = gamma(shape = 2, rate = 0.5, posterior.scale = 'sd')))
(fm3 <- blmer(Reaction ~ Days + (1 + Days|Subject), sleepstudy,
              control = control,
              cov.prior = wishart))
(fm4 <- blmer(Reaction ~ Days + (1 + Days|Subject), sleepstudy,
              control = control,
              cov.prior = invwishart(df = 5, scale = diag(0.5, 2))))

# Custom prior
penaltyFn <- function(sigma)
  dcauchy(sigma, 0, 10, log = TRUE)
(fm5 <- blmer(Reaction ~ Days + (0 + Days|Subject), sleepstudy,
              cov.prior = custom(penaltyFn, chol = TRUE, scale = "log")))


### Examples using a fixed effect prior ###
(fm6 <- blmer(Reaction ~ Days + (1 + Days|Subject), sleepstudy,
              cov.prior = NULL,
              fixef.prior = normal))
(fm7 <- blmer(Reaction ~ Days + (1 + Days|Subject), sleepstudy,
              cov.prior = NULL,
              fixef.prior = normal(cov = diag(0.5, 2), common.scale = FALSE)))

### Example using a residual variance prior ###
# This is the "eight schools" data set; the mode should be at the boundary
# of the space.

control <- lmerControl(check.conv.singular = "ignore",
                       check.nobs.vs.nRE   = "ignore",
                       check.nobs.vs.nlev  = "ignore")
y <- c(28, 8, -3, 7, -1, 1, 18, 12)
sigma <- c(15, 10, 16, 11, 9, 11, 10, 18)
g <- 1:8

(schools <- blmer(y ~ 1 + (1 | g), control = control, REML = FALSE,
                  resid.prior = point, cov.prior = NULL,
                  weights = 1 / sigma^2))
}
\keyword{models}
\keyword{methods}
